Information Bridge Framework Metadata Designer References

Metadata Designer References

Metadata Designer References

This reference provides documentation for Information Bridge metadata.

In This Section

Metadata Reference
Reference information for the XML elements and their attributes provided with the Information Bridge metadata schema.
Documentation Conventions
Information about the specific syntax conventions used in this reference.
Error Reference
This reference information can be found in the Microsoft® Office Information Bridge Framework Resource Kit.
Metadata User Interface Reference
This reference information can be found in the Information Bridge Framework Resource Kit.


Information Bridge Framework Metadata Schema Reference

Metadata Designer References

Metadata Schema Reference

Information Bridge includes an XML schema to define service operations, business entities, and user interface (UI) elements. Information Bridge technology uses this XML to move information among various sources without losing the metadata that is required to update the original source, such as a line-of-business (LOB) application.

This reference contains descriptions of each element and attribute defined in the Information Bridge metadata schema.

Alphabetical Element List

Metadata Hierarchy

The hierarchy of an Information Bridge Framework metadata schema appears as follows. A question mark "?" indicates that the element can appear zero or one time within the parent element. An asterisk "*" indicates that the element can appear zero or more times within the parent element.

<Metadata>
  <MetadataScopes> ?
    <MetadataScope> *
      <Entities> ?
        <Entity> *
          <Views> ?
            <View> *
              <MenuItemDefinition> ?
                <IsVisibleOperationInstance> ?
                <IsEnabledOperationInstance> ?
                <MenuDefinitionOperationInstance> ?
                <PortInstances> ?
                  <PortInstance> *
                    <AuthenticationDefinitionOperationInstance> ?
                    <LocationOperationInstance> ?
              <Actions> ?
                <Action> *
                  <MenuItemDefinition> ?
                    <IsVisibleOperationInstance> ?
                    <IsEnabledOperationInstance> ?
                    <MenuDefinitionOperationInstance> ?
                    <PortInstances> ?
                      <PortInstance> *
                        <AuthenticationDefinitionOperationInstance> ?
                        <LocationOperationInstance> ?
                  <OperationInstances> ?
                    <OperationInstance> *
                      <TransformationInstances> ?
                        <TransformationInstance> *
                  <PortInstances> ?
                    <PortInstance> *
                      <AuthenticationDefinitionOperationInstance> ?
                      <LocationOperationInstance> ?
              <Relationships> ?
                <Relationship> *
                  <MenuItemDefinition> ?
                    <IsVisibleOperationInstance> ?
                    <IsEnabledOperationInstance> ?
                    <MenuDefinitionOperationInstance> ?
                    <PortInstances> ?
                      <PortInstance> *
                        <AuthenticationDefinitionOperationInstance> ?
                        <LocationOperationInstance> ?
              <ViewLocators> ?
                <ViewLocator> *
                  <PortInstance> ?
                    <AuthenticationDefinitionOperationInstance> ?
                    <LocationOperationInstance> ?
      <Groups> ?
        <Group> *
      <Operations> ?
        <Operation> *
          <Groups> ?
            <Group> *
          <InputSchemas> ?
            <SchemaInstance> *
          <OutputSchemas> ?
            <SchemaInstance> *
          <Properties> ?
      <Ports> ?
        <Port> *
      <Schemas> ?
        <Schema> *
      <Transformations> ?
        <Transformation> *
      <Translations> ?
        <Translation> *
  <MetadataSolutions> ?
    <MetadataSolution> *
  <OperationTypes> ?
    <OperationType> *


Action

Metadata Designer Schema Reference

Action Element

Executes a set of OperationInstance elements.

<Action
  Comments = string
  InputSchemaName = name of a Schema element
  InputSchemaMetadataSolutionName = name of a MetadataSolution element
  MetadataSolutionName = name of a MetadaSolution element
  Name = string
  SequentialExecution = Boolean
  Type = string>
Content: (ActionPortInstances?), (MenuItemDefinition?), (OperationInstances?)
</Action>

Attributes

Attribute Name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this Action element.
InputSchemaName | string | No | A string containing the Name attribute of the Schema that this Action accepts as input.
InputSchemaMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element associated with the SchemaInstance element identified by the InputSchemaName attribute.
IsSequentialExecution | boolean | Yes | A Boolean value indicating whether or not Information Bridge will attempt to execute this Action element's OperationInstance and TransformationInstance elements one at a time in sequential order (as defined by the OperationInstance element's Index attribute).
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element with which this Action is associated, if any.
Name | string | Yes | A string of up to 64 characters in size containing the unique identifier for this Action.
Type | string | No | A string of up to 64 characters containing the type of this Action.

Element Information

Number of occurrences | Zero or more
Parent elements | Actions
Contents | PortInstances, MenuItemDefinition, OperationInstances

Remarks

The Action element defines the process of a user action taken in the user interface. For example, the user clicks a link in the task pane for a customer name. This executes the "GetCustomerInfo" Action element. "GetCustomerInfo" would contain a variety of OperationInstance elements that ultimately result in the customer information appearing in the task pane.

Action elements are composed of OperationInstance elements, which have TransformationInstance subelements that define the InputSchemas and OutputSchemas of the OperationInstance.

XSD Schema

<xs:complexType name="Action">
   <xs:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <xs:element minOccurs="0" maxOccurs="1" name="MenuItemDefinition" type="tns:MenuItemDefinition" />
      <xs:element minOccurs="0" maxOccurs="1" name="OperationInstances" type="tns:ArrayOfOperationInstance" />
      <xs:element minOccurs="0" maxOccurs="1" name="PortInstances" type="tns:ArrayOfPortInstance" />
   </xs:sequence>
   <xs:attribute name="Name" type="xs:string" />
   <xs:attribute name="MetadataSolutionName" type="xs:string" />
   <xs:attribute name="Type" type="xs:string" />
   <xs:attribute name="InputSchemaName" type="xs:string" />
   <xs:attribute name="InputSchemaMetadataSolutionName" type="xs:string" />
   <xs:attribute name="SequentialExecution" type="xs:boolean" use="required" />
   <xs:attribute name="Comments" type="xs:string" />
</xs:complexType>

See Also

Operation | Transformation | View


Comments Attribute

A string containing comments about an element.

Required | No
Default value | None

Remarks

The Comments string for Operation elements of all types can be longer than 1024 characters. For all other elements, the Comments string can be up to 16 kilobytes in size.

Applies To

Action | Entity | Group | MetadataScope | MetadataSolution | Operation | Port | Relationship | Schema | Transformation | View


InputSchemaMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element associated with the Schema element identified by the InputSchemaName attribute.

Required | No
Default value | None

Remarks

The InputSchemaName attribute combined with the InputSchemaMetadataSolutionName attribute uniquely identify the Schema element that the Action or Transformation element uses for input.

Applies To

Action | Transformation


InputSchemaName Attribute

A string containing the Name attribute of the Schema element that the Action or Transformation accepts as input.

Required | No
Default value | None

Remarks

If InputSchemaName is not defined for a Transformation, the Transformation generates text or XML without an input schema. In this case, the Transformation already has the input information integrated into itself.

The InputSchemaName attribute combined with the InputSchemaMetadataSolutionName uniquely identify the Schema element that the Action or Transformation element uses for input.

Applies To

Action | Transformation


IsSequentialExecution Attribute

A Boolean value indicating whether Information Bridge will attempt to execute this Action element's OperationInstance and TransformationInstance elements one at a time in sequential order (as defined by the OperationInstance element's Index attribute).

Required | Yes
Default value | False

Remarks

Even if this attribute is set to true, Information Bridge may not be able to execute the OperationInstance elements in sequential order due to input dependencies. For example, OperationInstance OpA has an Index value of 1 and OperationInstance OpB has an Index value of 2. But, if OpA requires input from OpB, OpB is executed first despite the fact that it has a later Index. For this reason, you pay close attention to the relationship between input dependencies of your OperationInstance elements and their Index attribute values to verify that they do not conflict.

Setting this attribute value to true significantly impacts the performance of this Action as the OperationInstance elements are executed on one thread.

If the OperationInstance elements cannot be executed in Index order, they are executed in order of their dependencies.

Applies To

Action


MetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element with which an element is associated, if any.

Required | No
Default value | None

Applies To

Action | Operation | Port | Relationship | Schema | Transformation


Name Attribute

A string of up to 64 characters containing the unique identifier for an element.

Required | Yes
Default value | None

Remarks

If the DisplayName attribute of MetadataScope or MetadataSolution is not defined, this Name attribute appears in the user interface instead.

The Name attribute for all other elements must be unique within the parent element for elements that have the same MetadataSolutionName. For example, within each Ports element, all Port elements with the same MetadataSolutionName values must have unique Name values.

The Name attribute for the Group element may not contain any of the following characters (asterisk, less than, greater than, vertical separator, colon, question mark, double-back slash, forward slash, quote):

*, <, >, |, :, ?, \\, /, "

If an element does not have the MetadataSolutionName attribute, all such elements within the same parent must have unique Name attributes.

Relationship elements must have Name attributes that are unique among Relationship elements within a MetadataScope.

Applies To

Action | Entity | Group | MetadataScope | MetadataSolution | Operation | OperationType | Port | Relationship | Schema | Transformation | View


Type Attribute

A string containing the type of this Action.

Required | No
Default value | None

Remarks

The Type attribute is provided to enable Action elements to be executed without knowing the Name attribute.

For example, you have a set of View elements that each have an Action element with a Type value of Search. You can identify and execute the Search Action for any of those View elements by specifying the Type attribute value of Search instead of the unique Name attribute.

The Type attribute value does not have to be unique. However, Information Bridge executes only a single occurrence (the first one it finds) of an Action with a specified Type value. Therefore, if you have multiple Action elements with the same Type within a View, you cannot be assured of which Action will be executed. Therefore, choose unique Type values for Action elements within a single View.

Examples of Type enabled by Information Bridge include the following:

  • EnterContext
  • Search

Applies To

Action


Actions

Metadata Designer Schema Reference

Actions Element

Contains zero or more Action elements.

<Actions>
Content: (Action*)
</Actions>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | View
Contents | Action

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Actions" type="s1:ArrayOfAction" />
</s:sequence>


AuthenticationDefinitionOperationInstance

Metadata Designer Schema Reference

AuthenticationDefinitionOperationInstance Element

Outputs the credentials (as a SchemaXsd) of file location for the parent PortInstance.

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | This attribute is not used for AuthenticationDefinitionOperationInstance elements and should be set to a value of 0.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Operation specified by the OperationName attribute.
OperationName | string | Yes | A string containing the Name attribute of the Operation to which this AuthenticationDefinitionOperationInstance refers.

Element Information

Number of occurrences | Zero or one
Parent elements | PortInstance
Contents | TransformationInstances

Remarks

This element is only required in the following two cases:

  • The Location of the parent PortInstance has security that requires a user name and password.
  • The parent PortInstance does not define a LocationOperationInstance but the Location of the Port that the parent PortInstance points to has a Location that has security that requires a user name and password.

The output SchemaInstance for AuthenticationDefinitionOperationInstance elements must be of type SchemaXsd and conform to the following schema:

<xs:element name="Credentials">
    <xs:complexType>
        <xs:all>
            <xs:element name="UserName" type="xs:string" />
            <xs:element name="Password" type="xs:string" />
            <xs:element name="DomainName" type="xs:string" minOccurs="0" />
        </xs:all>
    </xs:complexType>
</xs:element>

This element is not supported by Port elements of type PortAssembly, which always use Windows credentials.

XSD Schema

<s:complexType name="AuthenticationDefinitionOperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


Index Attribute

An integer defining the order in which an element is executed within a list of similar elements.

Required | Yes
Default value | None

Remarks

Even if the Action element's IsSequentialExecution attribute is set to true, Information Bridge Framework may not be able to execute the OperationInstance elements in sequential order due to input dependencies. For example, OperationInstance OpA has an Index value of 1 and OperationInstance OpB has an Index value of 2. But, if OpA requires input from OpB, OpB is executed first despite the fact that it has a later Index. For this reason, you should pay close attention to the relationship between input dependencies of your OperationInstance elements and their Index attribute values to make sure that they do not conflict.

If the parent Action element's IsSequentialExecution attribute is set to true, Information Bridge attempts to execute the OperationInstance and TransformationInstance elements in order of their Index values. If IsSequentialExecution is not set to true, these elements are not necessarily executed in order.

An error occurs if two or more TransformationInstance or OperationInstance elements in a TransformationInstances or OperationInstances, respectively, have the same value for the Index attribute.

OperationInstance Index Values

For an OperationInstance that is part of an Action, this attribute must be a positive integer value from 1 to N, where N is the number of OperationInstance elements in the OperationInstances subelement of the Action.

For OperationInstance elements that are not included in the OperationInstances subelement of an Action, the Index attribute can be 0.

TransformationInstance Index Values

For a TransformationInstance, this attribute must be a value from 1 to N, where N is the number of TransformationInstance elements in the TransformationInstances subelement of the OperationInstance. The Index attribute value of the TransformationInstance must also be equal to the Index attribute value of one of the SchemaInstance elements of the InputSchemas subelement of the Operation.

For the TransformationInstance subelements of OperationSoapRequest, set this attribute to a value from -1 to -N to map to the SOAP header. Set the value to 0 to map to the SOAP message, if one is available.

For TransformationInstance subelements of OperationExecuteAction, set this attribute to a value of -1 to map to the reference being passed to the Action. Set the value to 0 to map to the parameters.

Applies To

AuthenticationDefinitionOperationInstance | IsEnabledOperationInstance | IsVisibleOperationInstance | LocationOperationInstance | MenuDefinitionOperationInstance


OperationMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution that is associated with the Operation element identified by the OperationName attribute.

Required | No
Default value | None

Remarks

This attribute combined with the OperationName attribute uniquely identifies the Operation element associated with the OperationInstance.

Applies To

AuthenticationDefinitionOperationInstance | IsEnabledOperationInstance | IsVisibleOperationInstance | LocationOperationInstance | MenuDefinitionOperationInstance | OperationInstance


OperationName Attribute

A string containing the Name attribute of the Operation to which the OperationInstance refers.

Required | Yes
Default value | None

Applies To

AuthenticationDefinitionOperationInstance | IsEnabledOperationInstance | IsVisibleOperationInstance | LocationOperationInstance | MenuDefinitionOperationInstance


Entities

Metadata Designer Schema Reference

Entities Element

Contains zero or more Entity elements.

<Entities>
Content: (Entity*)
</Entities>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Entity

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Entities" type="s1:ArrayOfEntity" />
</s:sequence>


Entity

Metadata Designer Schema Reference

Entity Element

Represents a conceptual data type exposed by Information Bridge, such as a person, place, or thing.

<Entity
  Comments = string
  DefaultReferenceSchemaName = name of a Schema element
  DefaultViewName = name of a View element
  Name = string>
Content: (Views?)
</Entity>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string of up to 16 kilobytes in size that contains comments about this Entity element.
DefaultReferenceSchemaName | string | No | A string containing the Name attribute of the Schema element defining the default reference to this Entity.
DefaultViewName | string | No | A string containing the Name attribute of the default View element for this Entity.
Name | string | Yes | A string of up to 64 characters in size containing the unique identifier for this Entity.

Element Information

Number of occurrences | Zero or more
Parent elements | Entities
Contents | Views

Remarks

Examples of common Entity elements include Customer, Orders, and Invoice.

Although users see an Entity as a discrete unit, it can be assembled from data in various line-of-business (LOB) applications. For example, information in an Invoice can be pulled from a customer database and a separate products database.

The Entity element is the most important element of the metadata. It typically describes an entity in an LOB system. A Customer Entity element, for example, can be comprised of information from multiple sources, such as a customer entry in an enterprise resource planning (ERP) system or a customer relationship management (CRM) system. Different people or roles in the organization have different interests in these entities. For example, the financial view on the ERP customer, the payment history, or the order history of that customer.

XSD Schema

<s:complexType name="Entity">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="Views" type="s1:ArrayOfView" />
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="DefaultReferenceSchemaName" type="s:string" />
   <s:attribute name="DefaultViewName" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>

See Also

Operation


DefaultReferenceSchemaName

Metadata Designer Attribute Reference

DefaultReferenceSchemaName Attribute

A string containing the Name attribute of the Schema element defining the default reference to this Entity. The reference defined by this Schema is used by the ViewLocator to return the Schema of the View for this Entity element.

Required | No
Default value | None

Remarks

The ViewLocator identified by the DefaultReferenceSchemaName attribute must exist in the ViewLocators element of the View identified by the DefaultViewName attribute.

Applies To

Entity


DefaultViewName

Metadata Designer Attribute Reference

DefaultViewName Attribute

A string containing the Name attribute of the default View element for an Entity. This View must exist in the Views subelement of the Entity.

Required | No
Default value | None

Remarks

If Information Bridge has only a reference to the Entity, it navigates to this default View.

Applies To

Entity


EntityTimestamp

Metadata Designer Schema Reference

EntityTimestamp Element

Returns the last time an Entity or any of its subelements was modified.

<EntityTimeStamp
  EntityName = name of a Entity element
  Timestamp = dateTime
  AuthorizationHash = base64Binary>
Content: None
</EntityTimeStamp>

Attributes

Attribute name | Type | Required | Description
EntityName | string | Yes | A string containing the Name attribute of the Entity element to which this EntityTimestamp applies.
Timestamp | dateTime | Yes | A dateTime type containing the last date and time that the Entity identified by the EntityName attribute was modified.
AuthorizationHash | base64Binary | No | A binary type containing a computed value of the user credentials.

Element Information

Number of occurrences | Zero or more
Parent elements | EntityTimestamps
Contents | None

Remarks

The EntityTimestamp element is dynamically generated by the Web service and Metadata Designer tool. The EntityTimestamp element should not be altered without serious consideration of the repercussions.

An Entity is modified when any of the following occurs:

  • An element is added to the contents of the Entity.
  • An element is removed from the contents of the Entity.
  • An attribute of any of the elements contained in the Entity is changed.

XSD Schema

<s:complexType name="EntityTimestamp">
   <s:attribute name="EntityName" type="s:string" />
   <s:attribute name="Timestamp" type="s:dateTime" use="required"/>
   <s:attribute name="AuthorizationHash" type="s:base64Binary" />
</s:complexType>


AuthorizationHash Attribute

A binary type containing a computed value of user access settings.

Required | No
Default value | None

Remarks

Information Bridge uses this value to know when the client must refresh the local metadata because of a permission change. It is unlikely that you will have to modify this attribute.

Applies To

EntityTimestamp | MetadataScopeTimestamp| MetadataTimestamp


EntityName Attribute

A string containing the Name attribute of the Entity element to which an element applies.

Required | No (for Operation)
 | Yes (for EntityTimestamp)
Default value | None

Remarks

If this attribute is not defined for an Operation, the Operation is not associated with any Entity or View.

Applies To

EntityTimestamp | Operation


Timestamp Attribute

A dateTime value containing the last date and time an element was modified.

Required | Yes
Default value | None

Remarks

This attribute uses the International Standard ISO 8601 date and time format (YYYY-MM-DD hh:mm:ss). For more information about this ISO standard, see ISO Online.

Applies To

EntityTimestamp | MetadataScopeTimestamp | MetadataTimestamp


EntityTimestamps

Metadata Designer Schema Reference

EntityTimestamps Element

Contains zero or more EntityTimestamp elements.

<EntityTimestamps>
Content: (EntityTimestamp*)
</EntityTimestamps>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScopeTimestamp
Contents | EntityTimestamp

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="EntityTimestamps" type="s1:ArrayOfEntityTimestamp" />
</s:sequence>


Group

Metadata Designer Schema Reference

Group Element

Defines a classification mechanism to apply security to groups of Operation elements rather than to individual elements.

<Group
  Name = string
  Comments = string>
Content: None
</Group>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this Group element.
Name | string | Yes | A string of up to 64 characters in size containing the unique identifier for this Group.

Element Information

Number of occurrences | Zero or more
Parent elements | Groups
Contents | None

Remarks

To include an Operation as a member of a Group, specify the Group in the Groups subelement of the Operation.

The security for Information Bridge is handled by Authorization Manager. For more information, see the Information Bridge Framework Architecture and Planning Guide.

The Name attribute for the Group element cannot contain any of the following characters (asterisk, less than, greater than, vertical separator, colon, question mark, double-back slash, forward slash, quote):

*, <, >, |, :, ?, \\, /, "

XSD Schema

<s:complexType name="Group">
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


Groups

Metadata Designer Schema Reference

Groups Element

Contains zero or more Group elements.

<Groups>
Content: (Group*)
</Groups>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope, Operation
Contents | Group

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Groups" type="s1:ArrayOfGroup" />
</s:sequence>


InputSchemas

Metadata Designer Schema Reference

InputSchemas Element

Contains zero or more SchemaInstance elements.

<InputSchemas>
Content: (SchemaInstance*)
</InputSchemas>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Operation
Contents | SchemaInstance

Remarks

The SchemaInstance elements contained in the InputSchemas element define the data that the parent Operation expects as input.

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="InputSchemas" type="s1:ArrayOfSchemaInstance" />
</s:sequence>


IsEnabledOperationInstance

Metadata Designer Schema Reference

IsEnabledOperationInstance Element

Uses an OperationStatusCheck to return a Boolean value that indicates whether or not the parent MenuItemDefinition is enabled.

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | This attribute is not used for IsEnabledOperationInstance elements and must be set to a value of 0.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Operation specified by the OperationName attribute.
OperationName | string | Yes | A string containing the Name attribute of the OperationStatusCheck to which this IsEnabledOperationInstance refers.

Element Information

Number of occurrences | Zero or one
Parent elements | MenuItemDefinition
Contents | TransformationInstances

Remarks

If this element is not defined within a MenuItemDefinition, Information Bridge defaults to enabling the menu item (as if this element was defined and returned true).

XSD Schema

<s:complexType name="IsEnabledOperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


IsVisibleOperationInstance

Metadata Designer Schema Reference

IsVisibleOperationInstance Element

Uses an OperationStatusCheck to return a Boolean value that indicates whether or not the parent MenuItemDefinition is displayed.

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | This attribute is not used for IsVisibleOperationInstance elements and must be set to a value of 0.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Operation specified by the OperationName attribute.
OperationName | string | Yes | A string containing the Name attribute of the OperationStatusCheck to which this IsVisibleOperationInstance refers.

Element Information

Number of occurrences | Zero or one
Parent elements | MenuItemDefinition
Contents | TransformationInstances

Remarks

If this element is not defined within a MenuItemDefinition, Information Bridge defaults to displaying the menu item (as if this element was defined and returned true).

XSD Schema

<s:complexType name="IsVisibleOperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


LocationOperationInstance

Metadata Designer Schema Reference

LocationOperationInstance Element

Outputs a file, Web service, or assembly location as a SchemaString.

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | This attribute is not used for AuthenticationDefinitionOperationIn elements and must be set to a value of 0.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Operation specified by the OperationName attribute.
OperationName | string | Yes | A string containing the Name attribute of the Operation to which this LocationOperationInstance refers. This Operation should output a string.

Element Information

Number of occurrences | Zero or one
Parent elements | PortInstance
Contents | TransformationInstances

Remarks

The output of this element is used by the parent PortInstance to override the Location attribute of the Port identified by the PortName attribute.

If a PortInstance does not include this subelement, then the Location attribute of the Port will not be overridden.

XSD Schema

<s:complexType name="LocationOperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


MenuDefinitionOperationInstance

Metadata Designer Schema Reference

MenuDefinitionOperationInstance Element

Outputs XML that is used by OperationQueryMenu to display the caption and ToolTip for a menu item.

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | This attribute is not used for MenuDefinitionOperationInstance elements and must be set to a value of 0.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Operation specified by the OperationName attribute.
OperationName | string | Yes | A string containing the Name attribute of the Operation (OperationTransformationAggregation or OperationCallComponent are most appropriate) to which this MenuDefinitionOperationInstance refers.

Element Information

Number of occurrences | Zero or one
Parent elements | MenuItemDefinition
Contents | TransformationInstances

Remarks

The client (the software module that uses Information Bridge) using the output of the OperationQueryMenu is responsible for interpreting the output, thus also being responsible for interpreting the results of the MenuDefinitionOperationInstance.

If the client using the output of the OperationQueryMenu is the default Information Bridge Framework implementation, the MenuDefinitionOperationInstance must return XML that conforms to one of the two following schemas:

<s:element name="RegionProperties" type="RegionPropertiesType" xmlns:s="http://www.w3.org/2001/XMLSchema" />
<s:complexType name="RegionPropertiesType" xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:sequence>
      <s:any namespace="##any" processContents="lax" minOccurs="0" />
   </s:sequence>
   <s:attributeGroup ref="msibf:RegionAttributes" />
   <s:anyAttribute namespace="##any" processContents="lax" />
&</s:complexType>

<s:element name="ViewProperties" type="ViewPropertiesType" xmlns:s="http://www.w3.org/2001/XMLSchema"/>
<s:complexType name="ViewPropertiesType" xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:sequence>
      <s:any namespace="##any" processContents="lax" minOccurs="0" />
   </s:sequence>
   <s:attribute name="Caption" type="s:string" use="optional" default="" />
   <s:attribute name="Description" type="s:string" use="optional" default="" />
</s:complexType>

For more information about these XML schemas, see the Information Bridge Framework Resource Kit.

XSD Schema

<s:complexType name="MenuDefinitionOperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


MenuItemDefinition

Metadata Designer Schema Reference

MenuItemDefinition Element

Defines how and if an Action, Relationship, or View element appears in a menu.

Attributes

Attribute name | Type | Required | Description
MenuType | int | Yes | An integer that signifies the type of this menu.

Element Information

Number of occurrences | Zero or one
Parent elements | Action, Relationship, View
Contents | IsEnabledOperationInstance, IsVisibleOperationInstance, MenuDefinitionOperationInstance, PortInstances

XSD Schema

<xs:complexType name="MenuItemDefinition">
   <xs:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <xs:element minOccurs="0" maxOccurs="1" name="CheckIsVisibleOperationInstance" type="tns:OperationInstance" />
      <xs:element minOccurs="0" maxOccurs="1" name="CheckIsEnabledOperationInstance" type="tns:OperationInstance" />
      <xs:element minOccurs="0" maxOccurs="1" name="MenuDefinitionOperationInstance" type="tns:OperationInstance" />
      <xs:element minOccurs="0" maxOccurs="1" name="PortInstances" type="tns:ArrayOfPortInstance" />
   </xs:sequence>
   <xs:attribute name="MenuType" type="xs:int" use="required" />
</xs:complexType>


MenuType Attribute

A bit mask that signifies the type of a MenuItemDefinition.

Required | No
Default value | 1

Remarks

MenuType is used as a bit mask that can be used to specify numerous types depending on which bits are designated. A bit designated as 1 means that the menu item appears, and a bit value of 0 means the item does not appear. The default implementation included with Information Bridge only uses the first bit.

The default value for this attribute is 1 (by default, all MenuItemDefinition elements are of MenuType 1).

The OperationQueryMenu element filters its output using this MenuType attribute.

Applies To

MenuItemDefinition | OperationQueryMenu


Metadata

Metadata Designer Schema Reference

Metadata Element

Contains the definition of Information Bridge metadata.

<Metadata
  Version = string>
Content: (MetadataScopes?), (MetadataSolutions?), (OperationTypes?), (Timestamp?)
</Metadata>

Attributes

Attribute name | Type | Required | Description
Version | string | No | A string of up to 64 characters containing the version of the Metadata element.

Element Information

Number of occurrences | One time
Parent elements | (No parent elements)
Contents | MetadataScopes, MetadataSolutions, OperationTypes, Timestamp

Remarks

The Metadata element is the document element (the top-level element) in a metadata definition.

XSD Schema

<s:complexType name="Metadata">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="MetadataScopes" type="s1:ArrayOfMetadataScope" />
      <s:element minOccurs="0" maxOccurs="1" name="MetadataSolutions" type="s1:ArrayOfMetadataSolution" />
      <s:element minOccurs="0" maxOccurs="1" name="OperationTypes" type="s1:ArrayOfOperationType" />
      <s:element minOccurs="0" maxOccurs="1" name="Timestamp" type="s1:MetadataTimestamp" />
   </s:sequence>
   <s:attribute name="Version" type="s:string" />
</s:complexType>


Version Attribute

A string of up to 64 characters containing the version of the element.

Required | No
Default value | None

Remarks

For the Metadata element, for version one of the metadata, this attribute must have the format "#.#.#.#". For example, "1.0.0.0".

For MetadataScope and MetadataSolution, this attribute is for informational purposes only, and does not affect Information Bridge functionality.

Applies To

Metadata | MetadataScope | MetadataSolution


MetadataScope

Metadata Designer Schema Reference

MetadataScope Element

Partitions metadata by Web service, assembly, HTTP server, or any other line-of-business (LOB) component.

<MetadaScope
  Name = string
  DisplayName = string
  Version = string
  DefaultEntityName = name of an Entity element
  Comments = string>
Content: (Entities?), (Ports?), (Groups?), (Operations?), (Transformations?), (Schemas?), (Translations?)
</MetadataScope>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this MetadataScope element.
DefaultEntityName | string | No | A string of up to 64 characters containing the Name attribute of the default Entity for this MetadataScope.
DisplayName | string | No | A string containing the display name of this MetadataScope element that appears in the user interface.
Name | string | Yes | A string of up to 64 characters containing the unique identifier for this MetadataScope element.
Version | string | Yes | An informational string of up to 64 characters containing the version number for the MetadataScope element.

Element Information

Number of occurrences | Zero or more
Parent elements | MetadataScopes
Contents | Entities, Groups, Operations, Ports, Schemas, Transformations, Translations

Remarks

A MetadataScope describes a service, an assembly, an HTTP server or any other LOB component. Use it to contain the list of public Operation elements that can be invoked on the service (assembly, etc.), the schemas for the data types inputs and outputs, the Port containing the location of the service (SOAP, HTTP, file), and the Entity and View elements that contain the Action elements of the solutions built on top of the LOB component using Information Bridge Framework.

Each LOB application (for example, SAP or Siebel) should have its own MetadataScope.

XSD Schema

<s:complexType name="MetadataScope">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="Entities" type="s1:ArrayOfEntity" />
      <s:element minOccurs="0" maxOccurs="1" name="Ports" type="s1:ArrayOfPort" />
      <s:element minOccurs="0" maxOccurs="1" name="Groups" type="s1:ArrayOfGroup" />
      <s:element minOccurs="0" maxOccurs="1" name="Operations" type="s1:ArrayOfOperation" />
      <s:element minOccurs="0" maxOccurs="1" name="Transformations" type="s1:ArrayOfTransformation" />
      <s:element minOccurs="0" maxOccurs="1" name="Schemas" type="s1:ArrayOfSchema" />
      <s:element minOccurs="0" maxOccurs="1" name="Translations" type="s1:ArrayOfTranslation" />
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="DisplayName" type="s:string" />
   <s:attribute name="Version" type="s:string" />
   <s:attribute name="DefaultEntityName" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


DefaultEntityName Attribute

A string of up to 64 characters containing the Name attribute of the default Entity for the MetadataScope.

Required | No
Default value | None

Remarks

When Information Bridge executes an Action in a context in which only the name of the MetadataScope is known, the Entity identified by the DefaultEntityName will be used.

Applies To

MetadataScope


DisplayName Attribute

A string containing the display name of a MetadataScope or MetadataSolution element that appears in the Metadata Designer tool user interface.

Required | No
Default value | None

Remarks

Because the Name attribute must be unique and is usually a URI, you can specify DisplayName as a friendly name. DisplayName does not need to be unique.

If this attribute is not defined, the Name attribute appears in the user interface by default.

Applies To

MetadataScope | MetadataSolution


MetadataScopes

Metadata Designer Schema Reference

MetadataScopes Element

Contains zero or more MetadataScope elements.

<MetadataScopes>
Content: (MetadataScope*)
</MetadataScopes>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Metadata
Contents | MetadataScope

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="MetadataScopes" type="s1:ArrayOfMetadataScope" />
</s:sequence>


MetadataScopeTimestamp

Metadata Designer Schema Reference

MetadataScopeTimestamp Element

Returns the last time a MetadataScope was modified.

<MetadataScopeTimeStamp
  MetadataScopeName = name of a MetadataScope element
  Timestamp = dateTime
  AuthorizationHash = base64Binary>
Content: (EntityTimestamps?)
</MetadataScopeTimeStamp>

Attributes

Attribute name | Type | Required | Description
AuthorizationHash | base64Binary | No | A binary type containing a computed value of the user access settings to the Operation elements defined in this MetadataScope.
MetadataScopeName | string | No | A string containing the Name attribute of the MetadataScope element to which this MetadataScopeTimestamp applies.
Timestamp | dateTime | Yes | A dateTime value containing the last date and time that the MetadataScope identified by the MetadataScopeName attribute was modified.

Element Information

Number of occurrences | Zero or more
Parent elements | MetadataScopeTimestamps
Contents | EntityTimestamps

Remarks

This element also returns the AuthorizationHash. There are two attributes because the MetadataScope cannot be modified, but the user access settings can be updated by adding more users or restricting the access to any Operation elements of a particular MetadataScope.

MetadataScopeTimestamp is used in caching metadata. It is used to detect what changes were made in the metadata at caching refresh time.

A MetadataScope element is modified when any of the following occurs:

  • An element is added to the contents of the MetadataScope.
  • An element is removed from the contents of the MetadataScope.
  • An attribute of any of the elements contained in the MetadataScope is changed.

The EntityTimestamps subelement is used to keep track of changes in the Entity elements contained by the MetadataScope. For information about determining when an Entity is modified, see the EntityTimestamp element.

XSD Schema

<s:complexType name="MetadataScopeTimestamp">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="EntityTimestamps" type="s1:ArrayOfEntityTimestamp" />
   </s:sequence/>
   <s:attribute name="MetadataScopeName" type="s:string" />
   <s:attribute name="Timestamp" type="s:dateTime" use="required"/>
   <s:attribute name="AuthorizationHash" type="s:base64Binary" />
</s:complexType>


MetadataScopeName Attribute

A string containing the Name attribute of the MetadataScope element to which the MetadataScopeTimestamp applies.

Required | No
Default value | None

Applies To

MetadataScopeTimestamp


MetadataScopeTimestamps

Metadata Designer Schema Reference

MetadataScopeTimestamps Element

Contains zero or more MetadataScopeTimestamp elements.

<MetadataScopeTimestamps>
Content: (MetadataScopeTimestamp*)
</MetadataScopeTimestamps>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataTimestamp
Contents | MetadataScopeTimestamp

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="MetadataScopeTimestamps" type="s1:ArrayOfMetadataScopeTimestamp" />
</s:sequence>


MetadataSolution

Metadata Designer Schema Reference

MetadataSolution Element

Defines an Information Bridge metadata solution.

<MetadaSolution
  Name = string
  DisplayName = string
  Version = string
  Comments = string>
Content: None
</MetadataSolution>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this MetadataSolution element.
DisplayName | string | No | A string containing the display name of this MetadataSolution element that appears in the user interface.
Name | string | Yes | A string of up to 64 characters containing the unique identifier for this MetadataSolution.
Version | string | Yes | An informational string of up to 64 characters containing the version number for the MetadataSolution element.

Element Information

Number of occurrences | Zero or more
Parent elements | MetadataSolutions
Contents | None

Schema

<xs:complexType name="MetadataSolution">
   <xs:attribute name="MetadataSolutionName" type="xs:string" />
   <xs:attribute name="DisplayName" type="xs:string" />
   <xs:attribute name="Version" type="xs:string" />
   <xs:attribute name="Comments" type="xs:string" />
</xs:complexType>


MetadataSolutions

Metadata Designer Schema Reference

MetadataSolutions Element

Contains zero or more MetadataSolution elements.

<MetadataSolutions>
Content: (MetadataSolution*)
</MetadataSolutions>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Metadata
Contents | MetadataSolution

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="MetadataSolutions" type="s1:ArrayOfMetadataSolution" />
</s:sequence>


MetadataTimestamp

Metadata Designer Schema Reference

MetadataTimestamp Element

Returns the last time the Metadata was modified.

<MetadataTimeStamp
  RetrieveTime = dateTime
  Timestamp = dateTime
  AuthorizationHash = base64Binary>
Content: (MetadataScopeTimestamps?)
</MetadataTimeStamp>

Attributes

Attribute name | Type | Required | Description
AuthorizationHash | base64Binary | No | A binary type containing a computed value of the user access settings to the Operation elements defined in this Metadata.
RetrieveTime | dateTime | No | A dateTime value indicating the date and time that the Metadata element was checked for modifications.
Timestamp | dateTime | Yes | A dateTime value containing the last date and time that the Metadata was modified.

Element Information

Number of occurrences | Zero or one
Parent elements | Metadata
Contents | MetadataScopeTimestamps

Remarks

An Metadata is modified when any of the following occurs:

  • Any of the Metadata element's attributes are changed.
  • An element is added to the contents of the Metadata.
  • An element is removed from the contents of the Metadata.
  • An attribute of any of the elements contained in the Metadata is changed.

The MetadataScopeTimestamps subelement is used to keep track of changes in the MetadataScope elements contained by the Metadata. For information about determining when a MetadataScope element is modified, see the MetadataScopeTimestamp element.

XSD Schema

<s:complexType name="MetadataTimestamp">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="MetadataScopeTimestamps" type="s1:ArrayOfMetadataScopeTimestamp" />
   </s:sequence>
   <s:attribute name="RetrieveTime" type="s:dateTime" use="required" />
   <s:attribute name="Timestamp" type="s:dateTime" use="required" />
   <s:attribute name="AuthorizationHash" type="s:base64Binary" />
</s:complexType>


RetrieveTime Attribute

A dateTime indicating the last date and time that the Metadata element was checked for modifications.

Required | Yes
Default value | None

Applies To

MetadataTimestamp


Operation

Metadata Designer Schema Reference

Operation Element

Defines a basic unit of execution in Information Bridge.

<Operation
  Comments = string
  EntityName = Name of an Entity element
  MetadataSolutionName = Name of a MetadataSolution element
  Name = string
  TimeOut = int
  xsi:type = Qname>
Content: (Groups?), (InputSchemas?), (OutputSchemas?)
</Operation>

Attributes

In addition to the attributes listed below, all Operation elements have zero or more additional attributes depending upon their type (as defined by the xsi:type attribute).

Attribute name | Type | Required | Description
Comments | string | No | A string up to 1024 characters in size that contains comments about this element.
EntityName | string | No | A string containing the Name attribute of the Entity to which this element applies.
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element with which an element is associated, if any.
Name | string | Yes | A string of up to 64 characters containing the identifier for this element.
TimeOut | int | No | The amount of time, in seconds, that the Operation attempts to complete before failing.
xsi:type | Qname | Yes | A Qname of up to 64 characters in length containing the type of the Operation.

Element Information

Number of occurrences | Zero or more
Parent elements | Operations
Contents | Groups, InputSchemas, OutputSchemas

Remarks

Operation elements are used by OperationInstance elements to define behaviors.

The xsi:type attribute may have one of the values in the following table. The value identifies the type that provides additional functionality to the Operation.

Operation xsi:type Value | Element that defines the additional functionality
OperationBrowse | OperationBrowse
OperationCallComponent | OperationCallComponent
OperationCustom | OperationCustom
OperationExecuteAction | OperationExecuteAction
OperationNavigate | OperationNavigate
OperationQueryMenu | OperationQueryMenu
OperationReturnActionResult | OperationReturnActionResult
OperationSoapRequest | OperationSoapRequest
OperationStatusCheck | OperationStatusCheck
OperationTransformationAggregation | OperationTransformationAggregation

System integrators should use the OperationCustom element to define their own unique units of execution.

XSD Schema

<s:complexType name="Operation" abstract="true">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="InputSchemas" type="s1:ArrayOfSchemaInstance" />
      <s:element minOccurs="0" maxOccurs="1" name="OutputSchemas" type="s1:ArrayOfSchemaInstance" />
      <s:element minOccurs="0" maxOccurs="1" name="Groups" type="s1:ArrayOfGroup" />
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="MetadataSolutionName" type="s:string" />
   <s:attribute name="EntityName" type="s:string" />
   <s:attribute name="TimeOut" type="s:int" use="required" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


TimeOut Attribute

The amount of time, in seconds, that the Operation attempts to complete before failing.

Required | No
Default value | 0

Remarks

If this attribute is not defined, or set to a value less than or equal to zero, Information Bridge uses the default value of 120 as defined in the engine configuration file (Microsoft.InformationBridge.Framework.Config).

Applies To

OperationBrowse | OperationCallComponent | OperationCustom | OperationExecuteAction | OperationNavigate | OperationQueryMenu | OperationReturnActionResult | OperationSoapRequest | OperationStatusCheck | OperationTransformationAggregation |


xsi:type Attribute

A Qname of up to 64 characters in length containing the type of the element.

Required | Yes
Default value | None

Remarks

The Operation, Port, Schema, and Transformation elements must designate an xsi:type attribute. This type defines additional functionality available to the associated instance element (OperationInstance, PortInstance, SchemaInstance, or TransformationInstance) based on an element derived from one of the four elements named above.

Operation xsi:type Value | Element that defines the additional functionality
OperationBrowse | OperationBrowse
OperationCallComponent | OperationCallComponent
OperationCustom | OperationCustom
OperationExecuteAction | OperationExecuteAction
OperationNavigate | OperationNavigate
OperationQueryMenu | OperationQueryMenu
OperationReturnActionResult | OperationReturnActionResult
OperationSoapRequest | OperationSoapRequest
OperationTransformationAggregation | OperationTransformationAggregation
Port xsi:type Value | Element that defines the additional functionality
PortAssembly | PortAssembly
PortFile | PortFile
PortFileBinary | PortFileBinary
PortFileText | PortFileText
PortFileXml | PortFileXml
Schema xsi:type Value | Element that defines the additional functionality
SchemaString | SchemaString
SchemaXsd | SchemaXsd
Transformation xsi:type Value | Element that defines the additional functionality
TransformationImmediate | TransformationImmediate
TransformationImmediatePort | TransformationImmediatePort
TransformationRegularExpression | TransformationRegularExpression
TransformationXPath | TransformationXPath
TransformationXsl | TransformationXsl

Applies To

Operation | Port | Schema | Transformation


OperationBrowse

Metadata Designer Schema Reference

OperationBrowse Type

Executes an HTTP GET operation.

Attributes

OperationBrowse is a type of Operation. In addition to its other attributes, an Operation of type OperationBrowse includes the attributes listed in the following table.

Attribute name | Type | Required | Description
IsUpdate | boolean | Yes | An informational Boolean value indicating whether or not this OperationBrowse updates the server.
Parameters | string | No | A string containing hard-coded parameters of an HTTP request.
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the PortFile element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortFile element that is the target of the OperationBrowse.

Remarks

To define an Operation of type OperationBrowse, set the xsi:type attribute of an Operation equal to OperationBrowse.

The InputSchemas and OutputSchemas subelements of an Operation of type OperationBrowse can have zero or one SchemaInstance subelements each. The Index attribute of these SchemaInstance elements must have a value of 1.

This operation accepts only one input, which redefines the Parameters property. If this input is not provided, the hard-coded value of Parameters is used if available.

This operation has only one output, which returns a string with the result of the HTTP operation.

Schema

<xs:complexType name="OperationBrowse">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:attribute name="IsUpdate" type="xs:boolean" use="required" />
         <xs:attribute name="PortName" type="xs:string" />
         <xs:attribute name="PortMetadataSolutionName" type="xs:string" />
         <xs:attribute name="Parameters" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


IsUpdate Attribute

An informational Boolean value indicating whether or not this element updates the service.

Required | Yes
Default value | False

Remarks

Although IsUpdate is a required attribute, changing its value does not affect whether the element updates the server. Use this attribute as an indicator that the element updates the server.

Applies To

OperationBrowse | OperationCallComponent | OperationSoapRequest | OperationStatusCheck


Parameters Attribute

A string containing additional input parameters for an Operation element if they are not specified as input for the Operation.

Required | No
Default value | None

Remarks

The Parameters attribute enables you to hardcode the parameters of an Operation if they are not specified in the InputSchemas of the Operation.

An example of this attribute for an OperationBrowse for an HTTP request to http://mysite/myWeb.htm could look like the following:

Parameters = "?param1=Green&Param2=Blue"

Applies To

OperationBrowse | OperationCallComponent | OperationStatusCheck


PortMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution associated with the Port specified by the PortName attribute.

Required | No
Default value | None

Remarks

Applies To

OperationBrowse | OperationCallComponent | OperationCustom | OperationSoapRequest | OperationStatusCheck | PortInstance |SchemaXsd | TransformationImmediatePort | TransformationXsl


PortName Attribute

A string containing the Name attribute of a Port element.

Required | No for OperationCustom Yes for all others
Default value | None

Applies To

OperationBrowse | OperationCallComponent | OperationSoapRequest | PortInstance | SchemaXsd | TransformationImmediatePort | TransformationXsl


OperationCallComponent

Metadata Designer Schema Reference

OperationCallComponent Type

Executes a method call in a common language runtime (CLR) component.

Attributes

OperationCallComponent is a type of Operation. In addition to its other attributes, an Operation of type OperationCallComponent includes the attributes listed in the following table.

Attribute name | Type | Required | Description
ClassName | string | Yes | A string of up to 128 characters containing the name of the CLR class to instantiate.
IsUpdate | boolean | Yes | An informational Boolean value indicating whether or not this element updates the service.
MethodName | string | Yes | A string of up to 128 characters containing the name of the CLR method to call.
Parameters | string | No | A string containing additional input parameters for an Operation element if they are not specified as input for the Operation.
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the PortFile element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortAssembly element that contains the CLR object to be instantiated by the OperationCallComponent.

Remarks

To define an Operation of type OperationCallComponent, set the xsi:type attribute of an Operation equal to OperationCallComponent.

The InputSchemas subelement of an Operation of type OperationCallComponent can have zero or more SchemaInstance subelements. The Index attribute of these SchemaInstance elements must start at a value of 1.

The OutputSchemas subelement of an Operation of type OperationCallComponent can have zero or one SchemaInstance subelements. The Index attribute of this SchemaInstance element must have a value of 1.

An Operation of type OperationCallComponent is used to invoke a method on a specific class in a specific assembly. To support a method with multiple parameters, the number of SchemaInstance elements (of type SchemaString or SchemaXsd) in the InputSchemas subelement must match the number of parameters in the method.

SchemaInstance inputs of type SchemaString should be used for string parameters. SchemaInstance inputs of type SchemaXsd should be used for XML or other complex type parameters that work with XML serialization and deserialization. If the method uses complex types, the schema instance is deserialized into the parameters of the correct complex type when that method is invoked.

For example, given the complex type:

class ComplexType
{
  private string data;

  [XmlAttribute]
  public string Data { get { return data; } set { data = value; } }
}

and the method

public string MethodToBeInvoked(ComplexType arg)
{
...
}

the following XML data can be passed in when executing the operation:

<ComplexType Data="some data"/>

Operation elements of type OperationCallComponent serialize complex type results of the method to XML. For example, given the preceding complex type and the following method:

public ComplexType MethodToBeInvoked2(string arg)
{
...
}

When executed the complex type result is serialized to the following XML:

<ComplexType Data="result data"/>

The XML serialization/deserialization interprets the serialization attributes that are declared on the types being serialized/deserialized. See the XmlAttribute attribute in the preceding sample. XML serialization attributes defined on the method that can specify or override the namespace of returned XML are not interpreted.

XSD Schema

<xs:complexType name="OperationCallComponent">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:attribute name="IsUpdate" type="xs:boolean" use="required" />
         <xs:attribute name="PortName" type="xs:string" />
         <xs:attribute name="PortMetadataSolutionName" type="xs:string" />
         <xs:attribute name="ClassName" type="xs:string" />
         <xs:attribute name="MethodName" type="xs:string" />
         <xs:attribute name="Parameters" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


ClassName Attribute

A string of up to 128 characters containing the name of the common language runtime (CLR) class to instantiate.

Required | Yes
Default value | None

Remarks

This class must exist in the assembly identified by the PortName attribute.

Applies To

OperationCallComponent


MethodName Attribute

A string of up to 128 characters containing the name of the common language runtime (CLR) method to call.

Required | Yes
Default value | None

Remarks

The method must be a member of the class identified by the ClassName attribute.

The method prototype, as defined in the file identified by the PortName attribute, must have the following signature:

return_type methodname (param1, param2, ...)

return_type, param1, and param2 can be of type string or XmlNode.

Applies To

OperationCallComponent


OperationCustom

Metadata Designer Schema Reference

OperationCustom Type

Provides the framework for creating custom operations above and beyond those supplied with Information Bridge.

Attributes

OperationCustom is a type of Operation. In addition to its other attributes, an Operation of type OperationCustom includes the following attributes:

Attribute name | Type | Required | Description
OperationTypeName | string | Yes | A string containing the Name attribute of the OperationType element for this OperationCustom.
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element associated with the Port identified by the PortName attribute.
PortName | string | No | A string containing the Name attribute of a Port extension for this OperationCustom, if any.

Element Information

In addition to its other subelements, an Operation of type OperationCustom includes the Properties subelement.

Remarks

Operation elements of type OperationCustom read input from the Properties subelement. However, the data in the Properties subelement is ignored if the InputSchemas subelement contains any SchemaInstance elements, which is then used for input instead.

To define an Operation of type OperationCustom, set the xsi:type attribute of an Operation equal to OperationCustom.

The InputSchemas and OutputSchemas subelements of an Operation of type OperationCustom can have zero or one SchemaInstance subelements each. The Index attribute of these SchemaInstance elements must have a value of 1.

XSD Schema

<xs:complexType name="OperationCustom">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:sequence>
            <xs:element minOccurs="0" maxOccurs="1" name="Properties">
               <xs:complexType mixed="true">
                  <xs:sequence>
                     <xs:any />
                  </xs:sequence>
               </xs:complexType>
            </xs:element>
         </xs:sequence>
         <xs:attribute name="OperationTypeName" type="xs:string" />
         <xs:attribute name="PortName" type="xs:string" />
         <xs:attribute name="PortMetadataSolutionName" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


OperationTypeName Attribute

A string containing the Name attribute of the OperationType element for this OperationCustom.

Required | Yes
Default value | None

Applies To

OperationCustom


Properties

Metadata Designer Schema Reference

Properties Element

Contains an XmlNode defining the configuration data for the parent OperationCustom element.

<Properties>
Content: (Any)*
</Properties>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | OperationCustom
Contents | Any well-formed XML

Remarks

The contents of thisXmlNode are not limited by Information Bridge and depend entirely upon the specific implementation of the OperationCustom element.

For example, the following syntax is an example of one possible implementation (in this case the ShowRegion OperationCustom element). Different implementations could contain completely different content.

<Properties>
   <iwb:Region AssociationName="Region5" Enabled="true" xmlns:iwb=
"http://schemas.microsoft.com/InformationBridge/2004">
      <iwb:RegionProperties RegionName="Region5" Caption="Region Five"
      Description="Region Five" ShowAs="ExpandedRegion"
      TypeName="WindowsControlLibrary1.UserControl1" />
   </iwb:Region>
</Properties>

Properties can use a Schema from the OutputSchemas attribute of a previous Operation element.

XSD Schema

<s:element minOccurs="0" maxOccurs="1" name="Properties">
   <s:complexType mixed="true">
      <s:sequence xmlns:xs="http://www.w3.org/2001/XMLSchema">
         <s:any namespace="##any" processContents="lax" minOccurs="0" />
      </s:sequence>
   </s:complexType>
</s:element>


OperationExecuteAction

Metadata Designer Schema Reference

OperationExecuteAction Type

Executes a specified Action.

Attributes

OperationExecuteAction is a type of Operation. In addition to its other attributes, an Operation of type OperationExecuteAction includes the attributes listed in the following table.

Attribute name | Type | Required | Description
TargetActionMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the Action element identified by the TargetActionName attribute.
TargetActionName | string | Yes | A string containing the Name attribute of the Action to execute.
TargetActionType | string | Yes | A string of up to 64 characters containing the Type attribute of the Action element to execute.
TargetEntityName | string | No | A string containing the Name attribute of the Entity element that is targeted by the Action element identified by the TargetActionName attribute.
TargetMetadataScopeName | string | Yes | A string containing the Name attribute of the MetadataScope element that is associated with the Action element identified by the TargetActionName attribute.
TargetReferenceSchemaName | string | No | A string containing the Name attribute of the Schema element that is the target of the reference being provided as input to this Action.
TargetViewName | string | No | A string containing the Name attribute of the View element that is associated with the Entity and Action elements identified by the TargetEntityName and TargetActionName attributes, respectively.

Remarks

If either one of the TargetActionName or the TargetActionType attributes is defined, the other is not required. If both are defined, Information Bridge uses TargetActionName only.

To define an Operation of type OperationExecuteAction, set the xsi:type attribute of an Operation equal to OperationCallExecuteAction.

The InputSchemas subelement of an Operation of type OperationExecuteAction can have zero or two SchemaInstance subelements. These inputs are mapped to the inputs of the parent Action. The Index attribute of these SchemaInstance elements must have a value of -1 (indicating the context view reference of the Action) or 0 (indicating the parameters of the Action).

The OutputSchemas subelement of an Operation of type OperationExecuteAction can have zero or more SchemaInstance subelements. The number of SchemaInstance elements in the OutputSchemas depends on the number of output SchemaInstance elements specified in the OperationReturnActionResult of the target Action. The Index attribute of these SchemaInstance elements must start at a value of 1.

XSD Schema

<xs:complexType name="OperationExecuteAction">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:attribute name="TargetMetadataScopeName" type="xs:string" />
         <xs:attribute name="TargetEntityName" type="xs:string" />
         <xs:attribute name="TargetViewName" type="xs:string" />
         <xs:attribute name="TargetReferenceSchemaName" type="xs:string" />
         <xs:attribute name="TargetActionName" type="xs:string" />
         <xs:attribute name="TargetActionMetadataSolutionName" type="xs:string" />
         <xs:attribute name="TargetActionType" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


TargetActionMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element that is associated with the Action element identified by the TargetActionName attribute.

Required | No
Default value | None

Remarks

If the Action element does not have an associated MetadataSolution, the TargetActionMetadataSolutionName attribute is not required.

Applies To

OperationExecuteAction


TargetActionName Attribute

A string containing the Name attribute of the Action to execute.

Required | Yes
Default value | None

Remarks

If either one of the TargetActionName or the TargetActionType attributes is defined, the other is not required. If both are defined, Information Bridge uses TargetActionName only.

Applies To

OperationExecuteAction


TargetActionType Attribute

A string of up to 64 characters containing the Type attribute value of the Action element to execute.

Required | Yes
Default value | None

Remarks

If either one of the TargetActionName or the TargetActionType attributes is defined, the other is not required. If both are defined, Information Bridge uses TargetActionName only.

Information Bridge searches all the Action elements associated with the Entity identified by the TargetEntityName attribute and executes only the first Action element it locates with the matching Type. If there is more than one Action with the matching Type, only the first Action found is executed.

Information Bridge does not provide a warning or error if the TargetActionType attribute identifies a Type that is not defined.

Applies To

OperationExecuteAction


TargetEntityName Attribute

A string containing the Name attribute of the Entity element that is targeted by the Action element identified by the TargetActionName attribute.

Required | No
Default value | None

Applies To

OperationExecuteAction


TargetMetadataScopeName Attribute

A string containing the Name attribute of the MetadataScope element that is associated with the Action element identified by the TargetActionName attribute.

Required | Yes
Default value | None

Applies To

OperationExecuteAction


TargetReferenceSchemaName Attribute

A string containing the Name attribute of the Schema element that is the target of the reference being provided as input to this Action.

Required | No
Default value | None

Remarks

If TargetReferenceSchemaName is not specified, Information Bridge navigates to the default reference (defined by the DefaultReferenceSchemaName attribute of the Entity element) for the View identified by the TargetViewName attribute.

Applies To

OperationExecuteAction


TargetViewName Attribute

A string containing the Name attribute of the View element that is associated with the Entity and Action elements identified by the TargetEntityName and TargetActionName attributes, respectively.

Required | No
Default value | None

Applies To

OperationExecuteAction


OperationInstance

Metadata Designer Schema Reference

OperationInstance Element

Defines a specific instance of an Operation in an Action.

<OperationInstance
  OperationName = Name of an Operation element
  OperationMetadataSolutionName = Name of a MetadataSolution element
  Index = int>
Content: (TransformationInstances?)
</OperationInstance>

Attributes

Attribute name | Type | Required | Description
OperationName | string | Yes | A string containing the Name attribute of the Operation (or one of the elements extended from Operation) to which this OperationInstance refers.
Index | int | Yes | An integer defining the order in which this OperationInstance is executed within the OperationInstances.
OperationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution that is associated with the Operation element identified by the OperationName attribute.

Element Information

Number of occurrences | Zero or more in an OperationInstances element Zero or one in a ViewLocator element
Parent elements | OperationInstances, ViewLocator
Contents | TransformationInstances

Remarks

An Action element's OperationInstance elements are specified in the Action element's OperationInstances subelement.

OperationInstance elements are the individual steps that make up an Action. For example, get data from Web service, perform a transformation on that data, display the data in task pane, and insert markup into the document. An Action can consist of multiple OperationInstance elements. For example, an Action to show task information could have three OperationInstance elements:

  1. Retrieve the data for the specific account manager.
  2. Perform a transformation on the data.
  3. Show a form.

XSD Schema

<s:complexType name="OperationInstance">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
   </s:sequence>
   <s:attribute name="OperationName" type="s:string" />
   <s:attribute name="OperationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


OperationInstances

Metadata Designer Schema Reference

OperationInstances Element

Contains zero or more OperationInstance elements.

<OperationInstances>
Content: (OperationInstance*)
</OperationInstances>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Action
Contents | OperationInstance

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="OperationInstances" type="s1:ArrayOfOperationInstances" />
</s:sequence>


OperationNavigate

Metadata Designer Schema Reference

OperationNavigate Type

Executes a Relationship in the current View.

Attributes

OperationNavigate is a type of Operation. In addition to its other attributes, an Operation of type OperationNavigate includes the following attributes:

Attribute name | Type | Required | Description
RelationshipMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Relationship identified by the RelationshipName attribute.
RelationshipName | string | Yes | A string containing the Name attribute of the Relationship that this OperationNavigate uses to navigate to the new View.

Remarks

OperationNavigate returns a reference to the destination View pointed to by the Relationship.

To define an Operation of type OperationNavigate, set the xsi:type attribute of an Operation equal to OperationNavigate.

The InputSchemas and OutputSchemas subelements of an Operation of type OperationNavigate can have zero or one SchemaInstance subelements each. The Index attribute of these SchemaInstance elements must have a value of 1.

An Operation of type OperationNavigate performs a transformation of the current “view data” to a reference that can be used in a “target context”. The transformation and the “target context” are defined by the Relationship identified by the RelationshipName attribute. In other words, the result of the OperationNavigate is the result of the Transformation associated with the Relationship.

XSD Schema

<xs:complexType name="OperationNavigate">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:attribute name="RelationshipName" type="xs:string" />
         <xs:attribute name="RelationshipMetadataSolutionName" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


RelationshipMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution associated with the Relationship identified by the RelationshipName attribute.

Required | No
Default value | None

Applies To

OperationNavigate


RelationshipName Attribute

A string containing the Name attribute of the Relationship that this OperationNavigate uses to navigate to the new View.

Required | No
Default value | None

Applies To

OperationNavigate


OperationQueryMenu

Metadata Designer Schema Reference

OperationQueryMenu Type

Retrieves the list of Action, Relationship, or View elements available for the current View.

Attributes

OperationQueryMenu is a type of Operation. In addition to its other attributes, an Operation of type OperationQueryMenu includes the attributes listed in the following table.

Attribute name | Type | Required | Description
MenuType | int | Yes | An integer identifying the MenuType attribute of the MenuItemDefinition elements of the Action, Relationship, or View elements to retrieve.
QueryMenuTypeValue | string | Yes | A string containing the type of the MenuItemDefinition to retrieve.

Remarks

To define an Operation of type OperationQueryMenu, set the xsi:type attribute of an Operation equal to OperationQueryMenu.

The InputSchemas and OutputSchemas subelements of an Operation of type OperationQueryMenu can have zero or one SchemaInstance subelements each. The Index attribute of these SchemaInstance elements must have a value of 1.

The IsEnabledOperationInstance and IsVisibleOperationInstance elements modify the output of this OperationQueryMenu.

If a TransformationInstance is specified in the TransformationInstances attribute of this OperationQueryMenu element's OperationInstance, OperationQueryMenu does not generate the menu schema. Instead, for output, it uses the value from the OutputSchemaName attribute of the Transformation element associated with the TransformationInstance element.

XSD Schema

<xs:complexType name="OperationQueryMenu">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation">
         <xs:attribute name="QueryMenuTypeValue" type="tns:QueryMenuType" use="required" />
         <xs:attribute name="MenuType" type="xs:int" use="required" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


QueryMenuTypeValue Attribute

A string containing the type of the MenuItemDefinition to retrieve.

Required | No
Default value | None

Remarks

This attribute may have a value of Actions, Relationships, and/or Views.

If this attribute is set to Actions, OperationQueryMenu searches the Actions subelement of the current View. Any Action elements found with a MenuItemDefinition MenuType attribute that matches the OperationQueryMenu element's MenuType attribute are included in the OutputSchemas attribute of the Operation.

If this attribute is set to Relationships, OperationQueryMenu searches the Relationships subelement of the current View. Any Relationship elements found with a MenuItemDefinition MenuType attribute that matches the OperationQueryMenu element's MenuType attribute are included in the OutputSchemas attribute of the Operation.

If this attribute is set to Views, OperationQueryMenu searches the Views subelement of the current Entity. Any View elements found with a ViewLocator ReferenceSchemaName attribute that matches the ReferenceSchemaName of the current View attribute are included in the OutputSchemas attribute of the Operation.

Applies To

OperationQueryMenu


OperationReturnActionResult

Metadata Designer Schema Reference

OperationReturnActionResult Type

Returns results from an Action to an OperationExecuteAction.

Attributes

OperationReturnActionResult is a type of Operation. Operation elements of type OperationReturnActionResult possess all the standard Operation attributes.

Remarks

To define an Operation of type OperationReturnActionResult, set the xsi:type attribute of an Operation equal to OperationReturnActionResult.

The InputSchemas subelement of an Operation of type OperationReturnActionResult can have zero or more SchemaInstance subelement. The Index attribute of these SchemaInstance elements must start at a value of 1.

The OutputSchemas subelement of an Operation of type OperationReturnActionResult must contain zero SchemaInstance subelements.

The OutputSchemas subelement of the calling OperationExecuteAction element is used as the InputSchemas subelement of the OperationReturnActionResult element.

An Action may not have more than one OperationInstance of type OperationReturnActionResult in its OperationInstances subelement.

XSD Schema

<xs:complexType name="OperationReturnActionResult">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Operation" />
   </xs:complexContent>
</xs:complexType>


Operations

Metadata Designer Schema Reference

Operations Element

Contains zero or more Operation elements.

<Operations>
Content: (Operation*)
</Operations>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Operation

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Operations" type="s1:ArrayOfOperation" />
</s:sequence>


OperationSoapRequest

Metadata Designer Schema Reference

OperationSoapRequest Type

Executes a Simple Object Application Protocol (SOAP) request.

Attributes

OperationSoapRequest is a type of Operation. In addition to its other attributes, an Operation of type OperationSoapRequest includes the attributes listed in the following table.

Attribute name | Type | Required | Description
IsUpdate | boolean | Yes | A Boolean value indicating whether this OperationSoapRequest performs an update on the server.
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the PortSoap element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortSoap element that defines the target location of the SOAP request.
SoapAction | string | Yes | A string of up to 128 characters containing the SOAPAction associated with the SOAP method invoked by the OperationSoapRequest.
SoapBody | string | No | A string of up to 2 GB containing the body of the SOAP request.
SoapBodyWrapper | string | No | A string of up to 128 characters containing the fully qualified name of the XML element with which to wrap the parameters of the SOAP call.
SoapHeader | string | No | A string of up to 2 GB containing the XML specifying elements for inclusion in the header of the SOAP message.

Remarks

To define an Operation of type OperationSoapRequest, set the xsi:type attribute of an Operation equal to OperationSoapRequest.

The InputSchemas subelement of an Operation of type OperationSoapRequest can have zero or more SchemaInstance subelements. The Index attribute of these SchemaInstance elements can start from any negative integer value:

  • A value of -n to -1 indicates a SOAP header input.
  • 0 indicates the envelope. If the envelope is present, any other inputs are ignored.
  • A value of 1 or more indicates a SOAP call parameter.

The OutputSchemas subelement of an Operation of type OperationSoapRequest can have zero or more SchemaInstance subelements. The Index attribute of these SchemaInstance elements can be 0 or any positive integer:

  • A value of 0 indicates the whole response envelope.
  • A value of 1 or more indicates the corresponding SOAP result.

SOAP requests must have the Web services method parameters and result set wrapped in an enclosing XML node. For example, the following is a Web services method:

[WebMethod]
Public Account GetAccount(AccountName accountId) {
      return Account;
}

The method does not specifically request that the parameters wrapping style be Bare (see SoapParameterStyle Enumeration on MSDN®). Therefore, the default wrapping style requires wrapping the method XML input (AccountName in the previous example) as shown below:

The method input (AccountName in the following example) must be wrapped in the following XML:

<GetAccount xmlns=”http://WebServices/CRM”>
  <AccountName>string</AccountName>
</GetAccount>

The SchemaInstance content for this Operation would look like:

<AccountName>string</AccountName>

This wrapping is defined by the SoapBodyWrapper attribute:

SoapBodyWrapper = "http://WebServices/CRM:GetAccount"

The response appears as follows in the OutputSchemas element of the OperationSoapRequest element. This wrapping is defined in the SoapBody attribute.

<GetAccountResponse xmlns=”http://WebServices/CRM”>
  <Account/>
</GetAccountResponse >

XSD Schema

<s:complexType name="OperationSoapRequest">
   <s:complexContent mixed="false">
   <s:extension base="s1:Operation">
      <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
         <s:element minOccurs="0" maxOccurs="1" name="SoapHeader">
            <s:complexType mixed="true">
               <s:sequence>
                  <s:any />
               </s:sequence>
            </s:complexType>
         </s:element>
         <s:element minOccurs="0" maxOccurs="1" name="SoapBody">
            <s:complexType mixed="true">
               <s:sequence>
                  <s:any />
               </s:sequence>
            </s:complexType>
         </s:element>
      </s:sequence>
      <s:attribute name="IsUpdate" type="s:boolean" use="required" />
      <s:attribute name="PortName" type="s:string" />
      <s:attribute name="PortMetadataSolutionName" type="s:string" />
      <s:attribute name="SoapAction" type="s:string" />
      <s:attribute name="SoapBodyWrapper" type="s:QName" use="required" />
      </s:extension>
   </s:complexContent>
</s:complexType>


SoapAction Attribute

A string of up to 128 characters containing the SOAPAction associated with the SOAP method invoked by the OperationSoapRequest.

Required | No
Default value | None

Remarks

The SOAPAction is used as an HTTP request header field when executing the OperationSoapRequest to indicate the intent of the SOAP request.

This attribute is used when creating the HTTP header for the SOAP request. When the request is received by a Web service, the SOAPAction identified by this attribute is used to determine what method should be called.

For more information about SOAPAction, see www.w3.org/tr/soap.

Applies To

OperationSoapRequest


SoapBody Attribute

A string of up to 2 GB containing the body of the SOAP request.

Required | No
Default value | None

Remarks

This attribute is only used if the OperationSoapRequest has one input with Index equal to 0 and the OperationInstance that uses this OperationSoapRequest does not define the TransformationInstance associated with this input.

For SOAP body formatting standards, visit http://www.w3.org/.

Applies To

OperationSoapRequest


SoapBodyWrapper Attribute

A string of up to 128 characters containing the fully qualified name of the XML element with which to wrap the parameters of the SOAP call.

Required | No
Default value | None

Remarks

This value is required when the parameters sent to and from the XML Web service method being invoked are encapsulated within a single XML element following the Body element of the XML portion of a SOAP request or SOAP response.

For more information, see the SoapParameterStyle Enumeration on MSDN® and the WS-I recommendations at http://www.ws-i.org.

In the Metadata Designer tool, the format for this is, for example, "http://WebServices/CRM:GetAccount".

However, in the metadata files themselves, the namespace qualifier is abstracted out to a named xmlns attribute. The SoapBodyWrapper value is prefixed with the name of the xmlns attribute. For example,

xmlns:q1="http://WebServices/CRM" SoapBodyWrapper="q1:GetAccount"

Applies To

OperationSoapRequest


SoapHeader Attribute

A string of up to 2 GB containing the XML that specifies elements for inclusion in the header of the SOAP message.

Required | No
Default value | None

Remarks

For SOAP body formatting standards, visit http://www.w3.org/.

Applies To

OperationSoapRequest


OperationStatusCheck

Metadata Designer Schema Reference

OperationStatusCheck Type

Outputs a Boolean value.

Attributes

OperationStatusCheck is a type of OperationCallComponent. Operation elements of type OperationCallComponent possess all the OperationCallComponent attributes.

Remarks

OperationStatusCheck is used by the IsEnabledOperationInstance and IsVisibleOperationInstance elements to determine whether or not to enable or show the menu item as part of the response of the OperationQueryMenu.

The InputSchemas subelement of an Operation of type OperationStatusCheck can have zero or more SchemaInstance subelements. The Index attribute of these SchemaInstance elements must start at a value of 1.

The OutputSchemas subelement of an Operation of type OperationStatusCheck can have zero or one SchemaInstance subelements. The Index attribute of this SchemaInstance element must have a value of 1.

XSD Schema

<xs:complexType name="OperationStatusCheck">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:OperationCallComponent" />
   </xs:complexContent>
</xs:complexType>


OperationTransformationAggregation

Metadata Designer Schema Reference Back to element list

OperationTransformationAggregation Type

Aggregates multiple Transformation inputs into one Transformation output.

Attributes

OperationTransformationAggregation is a type of Operation. In addition to its other attributes, an Operation of type OperationTransformationAggregation includes the attributes listed in the following table.

Attribute name | Type | Required | Description
TransformationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Transformation that is specified by the TransformationName attribute.
TransformationName | string | No | A string containing the Name attribute of the TransformationXsl or TransformationImmediate elements that are applied to the InputSchemas subelement.

Remarks

To define an Operation of type OperationTransformationAggregation, set the xsi:type attribute of an Operation equal to OperationTransformationAggregation.

The InputSchemas subelement of an Operation of type OperationTransformationAggregation can have zero or more SchemaInstance subelements. The Index attribute of these SchemaInstance elements must start at a value of 1.

The OutputSchemas subelement of an Operation of type OperationTransformationAggregation can have zero or one SchemaInstance subelement. The Index attribute of this SchemaInstance element must have a value of 1.

In addition to aggregating multiple sources, this element may also be used to transform a single input into a single output.

An Operation of type OperationTransformationAggregation may only have one SchemaInstance in its OutputSchemas subelement.

The SchemaInstance element—identified by the InputSchemaName attribute of the Transformation elements that are in the TransformationInstances subelement of the OperationInstance element—is used for the InputSchemas subelement of the OperationTransformationAggregation.

The aggregation is performed by execution of an TransformationXsl using an XSLT processor extended with methods that permit access to the inputs of the OperationTransformationAggregation (see GetRootXPath and GetText, below). The TransformationXsl is not applied on the inputs of the OperationTransformationAggregation but instead it transforms a prefabricated XML document that contains only an empty root element.

To have access to the inputs of this OperationTransformationAggregation, the XSLT defined by the PortName attribute of the Transformation (of type TransformationXsl) identified by the TransformationName attribute must use the external object that Information Bridge supplies. The namespace of this external object is:

http://schemas.microsoft.com/InformationBridge/2004/Inputs

This external object exposes the following methods:

GetRootXPath(int index) returns the root element (not the root: /) of the XML input matched by the index parameter. This is useful for XPath queries inside XML inputs.

GetText(int index) returns the text value of the input located using the index parameter. When input is XML, it returns the value of the InnerXml property of the input.

For the XSL to be executed, it must be invoked to transform a well-known fragment of XML that only has a root element. This means the XSL must have a match of the root element as a starting template.

XSLT Example

For example, an OperationTransformationAggregation has the following content for two SchemaInstance elements contained in the InputSchemas:

<?xml version="1.0"?*>
<my:Document xmlns:my="my-namespace-uri">
  <my:Title>Title</my:Title>
</my:Document>

<?xml version="1.0"?>
<my:Document xmlns:my="my-namespace-uri">
  <my:Content>…</my:Content>
</my:Document>
The TransformationXsl used by the OperationTransformationAggregation defines the following XSLT:
<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl=http://www.w3.org/1999/XSL/Transform
  xmlns:my="my-namespace-uri"
  xmlns:e="http://schemas.microsoft.com/InformationBridge/2004/Inputs">
  <xsl:template match="/">
    <my:Result>
      <xsl:copy-of select="e:GetRootXPath(1)/my:Title"/>
      <xsl:apply-templates select="e:GetRootXPath(2)/my:Content">
    </my:Result>
    </xsl:template>

    <xsl:template match="my:Content">
      <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>

The XSLT is applied to prefabricated XML that has only one empty root element. Therefore the starting template must be:

<xsl:template match="/">
...
</xsl:template>

The apply-template elements in conjunction with the second <xsl:template> in the preceding sample shows how templates can be used to match on the XML nodes of any of the XML inputs.

The output of the OperationTransformationAggregation given the inputs and preceding XSLT appears as follows:

<?xml version="1.0"?>
<my:Result xmlns:my="my-namespace-uri">
  <my:Title>Title</my:Title>
  <my:Content>…</my:Content>
</my:Result>

XSD Schema

<s:complexType name="OperationTransformationAggregation">
   <s:complexContent mixed="false">
      <s:extension base="s1:Operation">
         <s:attribute name="TransformationName" type="s:string" />
         <s:attribute name="TransformationMetadataSolutionName" type="s:string" />
      </s:extension>
   </s:complexContent>
</s:complexType>


TransformationMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution associated with the Transformation specified by the TransformationName attribute.

Required | No
Default value | None

Remarks

If TransformationMetadataSolutionName is not defined, OperationTransformationAggregation passes the data without applying a Transformation. That is, the OutputSchemas subelement is exactly the same as the InputSchemas subelement.

Applies To

OperationTransformationAggregation


TransformationName Attribute

A string containing the Name attribute of a Transformation of type TransformationXsl or TransformationImmediate.

Required | No
Default value | None

Remarks

In the case of a TransformationImmediate, the OperationTransformationAggregation passes the data without any transformation or aggregation taking place.

In the case of a TransformationXsl, the OperationTransformationAggregation performs an XSL transformation that can aggregate multiple inputs and produce one result.

If TransformationName is not defined, OperationTransformationAggregation passes the data without applying a Transformation. That is, the OutputSchemas subelement is exactly the same as the InputSchemas subelement.

Applies To

OperationTransformationAggregation


OperationType

Metadata Designer Schema Reference

OperationType Element

Defines the type for an OperationCustom element.

<OperationType>
  Comments = string
  Name = string
Content: None
</OperationType>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this OperationType element. These comments appear in the Metadata Designer tool, and to anyone editing the metadata files directly.
Name | string | No | A string containing the identifier that uniquely identifies this OperationType element.

Element Information

Number of occurrences | Zero or more
Parent elements | OperationTypes
Contents | None

Remarks

Information Bridge provides three types of OperationCustom: GetData, ShowAssociations, and ShowRegion.

XSD Schema

<xs:complexType name="OperationType">
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</xs:complexType>


OperationTypes

Metadata Designer Schema Reference

OperationTypes Element

Contains zero or more OperationType elements.

<OperationTypes>
Content: (OperationType*)
</OperationTypes>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Metadata
Contents | OperationType

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="OperationTypes" type="s1:ArrayOfOperationType" />
</s:sequence>


OutputSchemas

Metadata Designer Schema Reference

OutputSchemas Element

Contains zero or more SchemaInstance elements.

<OutputSchemas>
Content: (SchemaInstance*)
</OutputSchemas>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Operation
Contents | SchemaInstance

Remarks

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="OutputSchemas" type="s1:ArrayOfSchemaInstance" />
</s:sequence>


Port

Metadata Designer Schema Reference

Port Element

Defines a location of a data source, assembly, or Web service.

<Port
  AuthenticationDefinition = XmlNode
  Name = string
  MetadataSolutionName = Name of a MetadataSolution element
  Location = string
  IsCached = boolean
  AuthenticationTypeValue = string
  Comments = string
  xsi:type = Qname>
Content: (Data*)
</Port>

Attributes

In addition to the attributes listed below, all Port elements will have zero or more additional attributes, depending on their type (as defined by the xsi:type attribute).

Attribute name | Type | Required | Description
AuthenticationDefinition | XmlNode | No | An XmlNode defining the authentication schema containing the user's name, password, and domain name.
AuthenticationTypeValue | string | Yes | A string of up to 64 characters defining the type of authentication used for the Web service.
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this Port element.
IsCached | boolean | Yes | A Boolean value indicating whether the data identified by the Port is cached on the user's client computer.
Location | string | No | A string of up to 1024 characters containing the URI (HTTP, HTTPS, or file) to the Web service, data source, or assembly defined by the Port.
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element associated with this Port.
Name | string | Yes | A string of up to 64 characters containing the unique (within the MetadataScope) identifier for this Port.
xsi:type | Qname | Yes | A Qname of up to 64 characters containing the type of the Port.

Element Information

Number of occurrences | Zero or more
Parent elements | Ports
Contents | Data

Remarks

Information Bridge supports common language runtime (CLR), Simple Object Application Protocol (SOAP), and file (text, XML, and binary) Port elements.

The xsi:type attribute may have one of the following values, which identifies the type that provides additional functionality to the Port:

Port xsi:type Value | Element that defines the additional functionality
PortAssembly | PortAssembly
PortFile | PortFile
PortFileBinary | PortFileBinary
PortFileText | PortFileText
PortFileXml | PortFileXml
PortSoap | PortSoap

XSD Schema

<s:complexType name="Port" abstract="true">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="AuthenticationDefinition">
         <s:complexType mixed="true">
            <s:sequence>
               <s:any />
            </s:sequence>
         </s:complexType>
      </s:element>
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="MetadataSolutionName" type="s:string"/>
   <s:attribute name="Location" type="s:string" />
   <s:attribute name="IsCached" type="s:boolean" use="required" />
   <s:attribute name="AuthenticationTypeValue" type="s1:AuthenticationType" use="required" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


AuthenticationDefinition Attribute

An XmlNode defining the authentication schema containing the user's name, password, and domain name.

Required | No
Default value | None

Remarks

The format for this XmlNode should be:

<xs:schema elementFormDefault="qualified" attributeFormDefault="unqualified"
targetNamespace="http://schemas.microsoft.com/InformationBridge/2004"
xmlns:xs="http://www.w3.org/2001/XMLSchema"
xmlns:msibf="http://schemas.microsoft.com/InformationBridge/2004">
   <xs:element name="Credentials">
      <xs:complexType>
         <xs:all>
            <xs:element name="UserName" type="xs:string" />
            <xs:element name="Password" type="xs:string" />
            <xs:element name="DomainName" type="xs:string" minOccurs="0" />
         </xs:all>
      </xs:complexType>
   </xs:element>
</xs:schema>

If AuthenticationTypeValue is set to None, AuthenticationDefinition is ignored.

If AuthenticationTypeValue is set to Basic, AuthenticationDefinition is required but the DomainName element of the XmlNode is ignored and only UserName and Password are used.

If AuthenticationTypeValue is set to Windows, then the DomainName, UserName, and Password of AuthenticationDefinition override the default Information Bridge behavior of using the current user’s credentials.

This user name and password information is stored in the metadata file and sent over the network in clear text. It is strongly recommended that you use a user account with minimal user rights and permissions in the domain and that you secure Information Bridge network traffic to minimize the risk of an unauthorized user gaining access to this account.

Applies To

Port | PortAssembly | PortFile | PortFileBinary | PortFileText | PortFileXML | PortSoap


AuthenticationTypeValue Attribute

A string of up to 64 characters defining the type of authentication used for the Web service.

Required | Yes
Default value | None

Remarks

The value for this attribute can be None, Windows, or Basic.

Applies To

Port | PortAssembly | PortFile | PortFileBinary | PortFileText | PortFileXML | PortSoap


IsCached Attribute

A Boolean value indicating whether the data identified by the Port is cached on the user's client computer.

Required | Yes
Default value | False

Remarks

If this attribute is set to true, users can work without being connected to the server.

If a connection to the Port exists, Information Bridge always checks to see if the data has changed at the source, even if IsCached is set to true. If the data has not changed at the source, the cached data is used.

The PortSoap and PortAssembly elements (extended from the base Port element) do not support the IsCached attribute.

Applies To

PortAssembly | PortFile | PortFileBinary | PortFileText | PortFileXML


Location Attribute

A string of up to 1024 characters containing the URI (HTTP, HTTPS, or file) to the Web service, data source, or assembly defined by the Port.

Required | No
Default value | None

Remarks

For example, http://server/... or file://server/share/filename.ext.

This attribute supports the use of environment variables in the URI. For example, <ApplicationData>\solution\portfile.xml. The expando must be enclosed in <>.

When a PortInstance element is associated with this Port (using the PortName attribute of the PortInstance), the Location attribute specified here is dynamically overridden by the SchemaString element that is output by the LocationOperationInstance subelement of the PortInstance element.

Applies To

PortAssembly | PortFile | PortFileBinary | PortFileText | PortFileXML | PortSoap


PortAssembly

Metadata Designer Schema Reference

PortAssembly Type

Defines the fully qualified name for an assembly.

Attributes

PortAssembly is a type of Port. In addition to its other attributes, a Port of type PortAssembly includes the following attributes:

Attribute name | Type | Required | Description
Assembly | string | No | A string containing the name of the assembly; for example, "myassembly".
Culture | string | No | A string of up to 64 characters containing the culture portion of the strong name for the assembly.
PublicKeyToken | string | No | A string of up to 64 characters containing the public key token portion of the strong name for the assembly.
Version | string | No | A string of up to 64 characters containing the version portion of the strong name for the assembly.

Remarks

The attributes define portions of the fully qualified name. For example,

myAssembly, Version=1.0.1234.0, Culture="en-US", PublicKeyToken=b77a5c561934e089c

If the Location attribute of the Port element of type PortAssembly is not defined, the Assembly, Culture, PublicKeyToken and Version attributes identify the assembly to be used. If Location is defined, it is used to locate the assembly and any defined Assembly, Culture, PublicKeyToken, or Version attributes are used to verify the identity of the assembly after it is located and loaded.

XSD Schema

<xs:complexType name="PortAssembly">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:PortFile">
         <xs:attribute name="Assembly" type="xs:string" />
         <xs:attribute name="Version" type="xs:string" />
         <xs:attribute name="Culture" type="xs:string" />
         <xs:attribute name="PublicKeyToken" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


Assembly Attribute

A string containing the name of the assembly; for example, "myassembly".

Required | No
Default value | None

Applies To

PortAssembly


Culture Attribute

A string of up to 64 characters containing the culture portion of the strong name for the assembly.

Required | No
Default value | None

Applies To

PortAssembly


PublicKeyToken Attribute

A string of up to 64 characters containing the public key token portion of the strong name for the assembly.

Required | No
Default value | None

Applies To

PortAssembly


PortFile

Metadata Designer Schema Reference

PortFile Type

Defines a file location or data.

Attributes

PortFile is a type of Port. Port elements of type PortFile possess all the standard Port attributes.

Remarks

The abstract PortFile provides a basic location definition for data sources used in Information Bridge. Instead of using PortFile, use one of the types based on it. There are three types of PortFile:

  • PortFileBinary
  • PortFileText
  • PortFileXML

XSD Schema

<s:complexType name="PortFile" abstract="true">
   <s:complexContent mixed="false">
      <s:extension base="s1:Port" />
   </s:complexContent>
</s:complexType>

See Also

PortAssembly


PortFileBinary

Metadata Designer Schema Reference

PortFileBinary Type

Defines a file location for a binary file.

Attributes

PortFileBinary is a type of Port. Port elements of type PortFileBinary possess all the standard Port attributes.

XSD Schema

<xs:complexType name="PortFileBinary">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:PortFile" />
   </xs:complexContent>
</xs:complexType>

Remarks

PortFileBinary can be an image file or any other binary file.


PortFileText

Metadata Designer Schema Reference

PortFileText Type

Defines a string.

Attributes

PortFileText is a type of Port. In addition to its other attributes, a Port of type PortFileText includes the following attributes:

Attribute name | Type | Required | Description
Data | string | No | A string of up to 65 kilobytes containing the text.

XSD Schema

<s:complexType name="PortFileText">
   <s:complexContent mixed="false">
   <s:extension base="s1:PortFile">
      <s:attribute name="Data" type="s:string" />
   </s:extension>
   </s:complexContent>
</s:complexType>

Remarks

If the Data attribute is defined, the content of the Data attribute defines the text string. Otherwise, the Location attribute of the Port points to a file containing the text string.

See Also

PortFile | PortFileXML


Data Attribute

A string of up to 65 kilobytes containing the text or XML.

Required | No
Default value | None

Remarks

If this attribute is defined, this text or XML string is used instead of the content of the file identified by the Location attribute.

If this attribute is not defined, the text or XML from the file identified by the Location attribute is used.

For PortFileXML, this attribute may contain an XML, XSD, or XSL fragment.

Applies To

PortFileText | PortFileXML


PortFileXML

Metadata Designer Schema Reference

PortFileXML Type

Defines an XML blob.

Attributes

PortFileXml is a type of Port. In addition to its other attributes, an Port of type PortFileXml includes the following attributes:

Attribute name | Type | Required | Description
Data | string | No | A string of up to 65 kilobytes containing the XML.

Remarks

If the Data attribute is defined, the content of the Data attribute defines the XML blob. Otherwise, the Location attribute of the Port points to a file containing the XML blob.

XSD Schema

<s:complexType name="PortFileXml">
   <s:complexContent mixed="false">
      <s:extension base="s1:PortFile">
         <s:sequence>
            <s:element minOccurs="0" maxOccurs="1" name="Data">
               <s:complexType mixed="true">
                  <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
                     <s:any />
                  </s:sequence>
               </s:complexType>
            </s:element>
         </s:sequence>
      </s:extension>
   </s:complexContent>
</s:complexType>

See Also

PortFile | PortFileText


PortInstance

Metadata Designer Schema Reference

PortInstance Element

Overrides the Location and AuthenticationDefinition attributes of a Port.

<PortInstance
  PortName = Name of a Port element
  PortMetadataSolutionName = Name of a MetadataSolution element>
Content: (AuthenticationDefinitionOperationInstance?), (LocationOperationInstance?)
</PortInstance>

Attributes

Attribute name | Type | Required | Description
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution associated with the Port specified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the Port that this PortInstance refers to.

Element Information

Number of occurrences | Zero or more in PortInstances Zero or one in ViewLocator
Parent elements | PortInstances, ViewLocator
Contents | AuthenticationDefinitionOperationInstance, LocationOperationInstance

Remarks

A PortInstance only overrides a Port during the context of one Action, one MenuItemDefinition, or one ViewLocator. For example, any OperationInstance elements of an Action that reference an overridden Port will use the PortInstance instead.

XSD Schema

<xs:complexType name="PortInstance">
   <xs:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <xs:element minOccurs="0" maxOccurs="1" name="LocationOperationInstance" type="tns:OperationInstance" />
      <xs:element minOccurs="0" maxOccurs="1" name="AuthenticationDefinitionOperationInstance" type="tns:OperationInstance" />
   </xs:sequence>
   <xs:attribute name="PortName" type="xs:string" />
   <xs:attribute name="PortMetadataSolutionName" type="xs:string" />
</xs:complexType>


PortInstances

Metadata Designer Schema Reference

PortInstances Element

Contains zero or more PortInstance elements.

<PortInstances>
Content: (PortInstance*)
</PortInstances>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Action, MenuItemDefinition
Contents | PortInstance

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="PortInstances" type="s1:ArrayOfPortInstance" />
</s:sequence>


Ports

Metadata Designer Schema Reference

Ports Element

Contains zero or more Port elements.

<Ports>
Content: (Port*)
</Ports>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Port

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Ports" type="s1:ArrayOfPort" />
</s:sequence>


PortSoap

Metadata Designer Schema Reference

PortSoap Type

Defines the location of Web service.

Attributes

PortSoap is a type of Port. Port elements of type PortSoap possess all the standard Port attributes.

XSD Schema

<s:complexType name="PortSoap">
   <s:complexContent mixed="false">
      <s:extension base="s1:Port">
   </s:complexContent>
</s:complexType>


Relationship

Metadata Designer Schema Reference

Relationship Element

Defines how to navigate from the current View to a reference of a different View.

<Relationship
  Name = string
  MetadataSolutionName = name of a MetadataSolution element
  TransformationName = name of a Transformation element
  TransformationMetadataSolutionName = name of a MetadataSolution element
  TargetMetadataScopeName = name of a MetadataScope element
  TargetEntityName = name of a Entity element
  TargetViewName = name of a View element
  TargetReferenceSchemaName = name of a ViewLocator element
  Comments = string>
Content: (MenuItemDefinition)?
</Relationship>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string of up to 16 kilobytes in size that contains comments about this Relationship.
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element with which this Relationship is associated.
Name | string | Yes | A string of up to 64 characters containing the unique identifier for this Relationship.
TargetEntityName | string | Yes | A string containing the Name attribute of the Entity element to which the View identified by the TargetViewName attribute applies.
TargetMetadataScopeName | string | Yes | A string containing the Name attribute of the MetadataScope element with which target Entity (identified by the TargetEntityName attribute) and target View (identified by the TargetViewName attribute) are associated.
TargetReferenceSchemaName | string | No | A string containing the Name attribute of the target ViewLocator.
TargetViewName | string | Yes | A string containing the Name attribute of the target View.
TransformationMetadataSolutionName | string | Yes | A string containing the Name attribute of the MetadataSolution element with which the Transformation identified by the TransformationName attribute is associated.
TransformationName | string | Yes | A string containing the Name attribute of the Transformation element applied to current View element.

Element Information

Number of occurrences | Zero or more
Parent elements | Relationships
Contents | MenuItemDefinition

Remarks

A Relationship defines a Transformation from the source View element's Schema to the target's reference Schema. The OperationNavigate executes that Relationship.

A Relationship element is used by an OperationNavigate element to create a reference to the target View identified by the TargetViewName attribute. The OperationNavigate does not execute any Action of the target View. To execute an Action of the target View, use the OperationExecuteAction with the reference provided by the result of the OperationNavigate.

Information Bridge uses the instance data of the original View and applies the Transformation identified by the TransformationName attribute. The Transformation generates a reference for the target View.

XSD Schema

<s:complexType name="Relationship">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="MenuItemDefinition" type="s1:MenuItemDefinition" />
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="MetadataSolutionName" type="s:string" />
   <s:attribute name="TransformationName" type="s:string" />
   <s:attribute name="TransformationMetadataSolutionName" type="s:string" />
   <s:attribute name="TargetMetadataScopeName" type="s:string" />
   <s:attribute name="TargetEntityName" type="s:string" />
   <s:attribute name="TargetViewName" type="s:string" />
   <s:attribute name="TargetReferenceSchemaName" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


TargetEntityName Attribute

A string containing the Name attribute of the Entity element to which the View identified by the TargetViewName attribute applies.

Required | Yes
Default value | None

Applies To

Relationship


TargetMetadataScopeName Attribute

A string containing the Name attribute of the MetadataScope element with which target Entity (identified by the TargetEntityName attribute) and target View (identified by the TargetViewName attribute) are associated.

Required | Yes
Default value | None

Remarks

This MetadataScope can be in any MetadataSolution.

Applies To

Relationship


TargetReferenceSchemaName Attribute

A string containing the Name attribute of the target ViewLocator.

Required | Yes
Default value | None

Remarks

If this attribute is not defined, or a ViewLocator with this Name attribute does not exist, Information Bridge instead navigates to the default ViewLocator identified by the DefaultReferenceSchemaName attribute of the target Entity element (identified by the TargetEntityName attribute).

Applies To

Relationship


TargetViewName Attribute

A string containing the Name attribute of the target View.

Required | Yes
Default value | None

Remarks

If a View with this Name attribute does not exist, Information Bridge instead navigates to the default View for the Entity identified by the TargetEntityName attribute.

Applies To

Relationship


TransformationMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element with which the Transformation identified by the TransformationName attribute is associated.

Required | No
Default value | None

Applies To

Relationship


Relationships

Metadata Designer Schema Reference

Relationships Element

Contains zero or more Relationship elements.

<Relationships>
Content: (Relationship*)
</Relationships>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | View
Contents | Relationship

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Relationships" type="s1:ArrayOfRelationships" />
</s:sequence>


Schema

Metadata Designer Schema Reference

Schema Element

Defines the structure of data sent through the Information Bridge system.

<Schema
  Name = string
  MetadataSolutionName = Name of a MetadataSolution element
  Comments = string
  xsi:type = Qname>
Content: ({any})*
</Schema>

Attributes

In addition to the attributes listed below, all Schema elements have zero or more additional attributes, depending on their type (as defined by the xsi:type attribute).

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this Schema element.
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element with which this Schema is associated.
Name | string | Yes | A string of up to 64 characters containing the unique (within the MetadataScope) identifier for this Schema.
xsi:type | Qname | Yes | A Qname of up to 64 characters containing the type of this Schema.

Element Information

Number of occurrences | Zero or more
Parent elements | Schemas
Contents | Any well-formed XML content

Remarks

Schema can be just a simple string by using the SchemaString type. In this case it could be used as a simple parameter, for example. Alternately, using the SchemaXsd type, it can contain a predefined XSD structure for validation.

The xsi:type attribute may have one of the following values, which identifies the type that provides additional functionality to the Operation:

Schema xsi:type Value | Element that defines the additional functionality
SchemaString | SchemaString
SchemaXsd | SchemaXsd

XSD Schema

<s:complexType name="Schema" abstract="true">
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="MetadataSolutionName" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


SchemaInstance

Metadata Designer Schema Reference

SchemaInstance Element

Identifies a specific Schema.

<SchemaInstance
  SchemaName = Name of a Schema element
  SchemaMetadataSolutionName = Name of a MetadataSolution element
  Index = int>
Content: None
</SchemaInstance>

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | An integer defining the order in which this SchemaInstance is processed by the Operation or Transformation element that uses it.
SchemaMetadataSolutionName | string | Yes | A string containing the Name attribute of the MetadataSolution associated with the Schema identified by the SchemaName attribute.
SchemaName | string | Yes | A string containing the Name attribute of the Schema element used by this SchemaInstance.

Element Information

Number of occurrences | Zero or more
Parent elements | InputSchemas, OutputSchemas
Contents | None

Remarks

SchemaInstance elements are used for both input and output data of Operation and Transformation elements.

XSD Schema

<s:complexType name="SchemaInstance">
   <s:attribute name="SchemaName" type="s:string" />
   <s:attribute name="SchemaMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
</s:complexType>


SchemaMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution associated with the Schema identified by the SchemaName attribute.

Required | Yes
Default value | None

Applies To

SchemaInstance


SchemaName Attribute

A string containing the Name attribute of the Schema element used by this SchemaInstance.

Required | Yes
Default value | None

Applies To

SchemaInstance


Schemas

Metadata Designer Schema Reference

Schemas Element

Contains zero or more Schema elements.

<Schemas>
Content: (Schema*)
</Schemas>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Schema

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Schemas" type="s1:ArrayOfSchema" />
</s:sequence>


SchemaString

Metadata Designer Schema Reference

SchemaString Type

Defines a Schema containing a string.

Attributes

SchemaString is a type of Schema. Schema elements of type SchemaString possess all the standard Schema attributes.

XSD Schema

<s:complexType name="SchemaString">
   <s:complexContent mixed="false">
      <s:extension base="s1:Schema" />
   </s:complexContent>
</s:complexType>


SchemaXsd

Metadata Designer Schema Reference

SchemaXsd Type

Defines the source for an XSD data structure.

Attributes

SchemaXsd is a type of Schema. In addition to its other attributes, a Schema of type SchemaXsd includes the following attributes:

Attribute name | Type | Required | Description
Element | QName | Yes | An XML-qualified name indicating the specific XML element in the XML schema that is the source for the data for this SchemaXsd.
PortMetadataSolutionName | string | Yes | A string containing the Name attribute of the MetadataSolution element that is associated with the Port element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortFile element that points to or contains the XSD schema.

Remarks

Code Sample

The following XML code snippet defines two Schema elements of type SchemaXsd with Name attributes of CustomerReference (http://CustomerData) and CustomerContactInfo (http://CustomerData). The PortName attribute indicates the Port element that defines the source of the data. The Element attribute indicates the specific XML schema element that supplies the data for the SchemaXsd. The data for the CustomerReference (http://CustomerData) SchemaXsd is taken from the CustomerReference element. The data for the CustomerContactInfo (http://CustomerData) is taken from the CustomerContactInfo element.

<Schemas>
   <Schema xsi:type="SchemaXsd" Name="CustomerReference (http://CustomerData)"
   PortName="http://CustomerData" xmlns:q3="http://CustomerData" Element="q3:CustomerReference" />
   <Schema xsi:type="SchemaXsd" Name="CustomerContactInfo (http://CustomerData)"
   PortName="http://CustomerData" xmlns:q4="http://CustomerData" Element="q4:CustomerContactInfo" />
</Schemas>

The following XML schema element snippet defines the data structure of the CustomerReference and CustomerContactInfo elements that are used by the CustomerReference (http://CustomerData) and CustomerContactInfo (http://CustomerData) SchemaXsd elements defined above. The Element properties of the SchemaXsd defined above map to the XML Element elements defined below.

<xs:schema xmlns:tns="http://CustomerData" elementFormDefault="qualified" targetNamespace="http://CustomerData"
xmlns:xs="http://www.w3.org/2001/XMLSchema">
   <xs:element name="CustomerReference" type="tns:CustomerReference" />
   <xs:complexType name="CustomerReference">
      <xs:attribute name="id" type="xs:int" use="required" />
   </xs:complexType>
   <xs:element name="CustomerContactInfo" type="tns:CustomerContactInfo" />
   <xs:complexType name="CustomerContactInfo">
      <xs:sequence>
         <xs:element minOccurs="0" maxOccurs="1" name="name" type="xs:string" />
         <xs:element minOccurs="0" maxOccurs="1" name="address" type="xs:string" />
         <xs:element minOccurs="0" maxOccurs="1" name="phone" type="xs:string" />
      </xs:sequence>
      <xs:attribute name="id" type="xs:int" use="required" />
   </xs:complexType>
</xs:schema>

The CustomerReference (http://CustomerData) SchemaXsd pulls its data from the CustomerReference element, and therefore would contain a simple int that represents the id of the customer.

CustomerContactInfo (http://CustomerData) SchemaXsd pulls its data from the CustomerContactInfo element. It contains name, address, and phone information.

XSD Schema

<s:complexType name="SchemaXsd">
   <s:complexContent mixed="false">
      <s:extension base="s1:Schema">
         <s:attribute name="PortName" type="s:string" />
         <s:attribute name="PortMetadataSolutionName" type="s:string" />
         <s:attribute name="Element" type="s:QName" use="required" />
      </s:extension>
   </s:complexContent>
</s:complexType>


Element Attribute

An XML-qualified name indicating the specific XML element in the XML schema that is the source for the data for the SchemaXsd.

Required | Yes
Default value | None

Applies To

SchemaXsd


Transformation

Metadata Designer Schema Reference

Transformation Element

Defines how one SchemaInstance element's data structure is transformed into another SchemaInstance element's data structure.

<Transformation
  Name = string
  MetadataSolutionName = Name of a MetadataSolution element
  InputSchemaName = Name of an SchemaInstance element
  InputSchemaMetadataSolutionName = Name of a MetadataSolution element
  OutputSchemaName = Name of an SchemaInstance element
  OutputSchemaMetadataSolutionName = Name of a MetadataSolution element
  Comments = string
  xsi:type = Qname>
Content: ({any})*
</Transformation>

Attributes

In addition to the attributes listed below, all Transformation elements have zero or more additional attributes, depending on their type (as defined by the xsi:type attribute).

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this Transformation element.
InputSchemaMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the SchemaInstance element identified by the InputSchemaName attribute.
InputSchemaName | string | No | A string containing the Name attribute of the input SchemaInstance for this Transformation.
MetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element associated with this Transformation.
Name | string | Yes | A string of up to 64 characters containing the unique (within the MetadataScope) identifier for this Transformation.
OutputSchemaMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the SchemaInstance element identified by the OutputSchemaName attribute.
OutputSchemaName | string | Yes | A string containing the Name attribute of the output SchemaInstance for the Transformation.
xsi:type | Qname | Yes | A Qname of up to 64 characters containing the type of the Operation.

Element Information

Number of occurrences | Zero or more
Parent elements | Transformations
Contents | Any well-formed XML content

Remarks

During the course of executing a series of OperationInstance elements, it may be necessary at times to transform data generated by one OperationInstance element into a format that another OperationInstance element can use. For example, if you use a SOAP call to get a list of users, and need to transform the results of that SOAP call into a different XML format to send to a different Web service, this is done through the use of Transformation elements.

The xsi:type attribute may have one of the following values, which identifies the type that provides additional functionality to the Transformation:

Transformation xsi:type Value | Element that defines the additional functionality
TransformationImmediate | TransformationImmediate
TransformationImmediatePort | TransformationImmediatePort
TransformationRegularExpression | TransformationRegularExpression
TransformationXPath | TransformationXPath
TransformationXsl | TransformationXsl

XSD Schema

<s:complexType name="Transformation" abstract="true">
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="MetadataSolutionName" type="s:string" />
   <s:attribute name="InputSchemaName" type="s:string" />
   <s:attribute name="InputSchemaMetadataSolutionName" type="s:string" />
   <s:attribute name="OutputSchemaName" type="s:string" />
   <s:attribute name="OutputSchemaMetadataSolutionName" type="s:string" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


OutputSchemaMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element that is associated with the SchemaInstance identified by the OutputSchemaName attribute.

Required | No
Default value | None

Applies To

Transformation


OutputSchemaName Attribute

A string containing the Name attribute of the output SchemaInstance for the Transformation.

Required | Yes
Default value | None

Applies To

Transformation


TransformationImmediate

Metadata Designer Schema Reference

TransformationImmediate Type

Takes a SchemaInstance and outputs the same SchemaInstance without changing it.

Attributes

TransformationImmediate is a type of Transformation. Transformation elements of type TransformationImmediate possess all the standard Transformation attributes.

Remarks

Because every OperationInstance requires a Transformation, you should use TransformationImmediate when you do not need to change the SchemaInstance elements from the InputSchemas to the OutputSchemas.

Use TransformationImmediate in the following cases:

  • Mapping two SchemaInstance elements that are the same but have different names.
  • Carrying an output SchemaInstance into the same input SchemaInstance.

XSD Schema

<s:complexType name="TransformationImmediate">
   <s:complexContent mixed="false">
      <s:extension base="s1:Transformation" />
   </s:complexContent>
</s:complexType>


TransformationImmediatePort

Metadata Designer Schema Reference

TransformationImmediatePort Type

Reads data from a specified Port.

Attributes

TransformationImmediatePort is a type of Transformation. In addition to its other attributes, a Transformation of type TransformationImmediatePort includes the attributes listed in the following table.

Attributes name | Type | Required | Description
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the PortFile element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortFile element that specifies either data or the location of the data.

Remarks

TransformationImmediatePort can be used to get data from a Port to be used for an Operation element's input SchemaInstance.

XSD Schema

<xs:complexType name="TransformationImmediatePort">
   <xs:complexContent mixed="false">
      <xs:extension base="tns:Transformation">
         <xs:attribute name="PortName" type="xs:string" />
         <xs:attribute name="PortMetadataSolutionName" type="xs:string" />
      </xs:extension>
   </xs:complexContent>
</xs:complexType>


TransformationInstance

Metadata Designer Schema Reference

TransformationInstance Element

Defines a specific instance of a Transformation element (of any type).

<TransformationInstance
  TransformationName = Name of a Transformation element
  TransformationMetadataSolutionName = Name of a MetadataSolution element
  Index = int
  InputOperationIndex = int
  InputOperationOutputSchemaIndex = int
Content: None
</PortInstance>

Attributes

Attribute name | Type | Required | Description
Index | int | Yes | An integer defining the order in which this TransformationInstance is executed within the list of TransformationInstance elements in the TransformationInstances subelement.
InputOperationIndex | int | Yes | An integer defining the input Schema for this TransformationInstance.
InputOperationOutputSchemaIndex | int | No | An integer that identifies the Index attribute of the SchemaInstance element from the OutputSchemas subelement of the OperationInstance that is identified by the InputOperationIndex attribute.
TransformationMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element associated with this TransformationInstance.
TransformationName | string | No | A string containing the Name attribute of the Transformation element to which this TransformationInstance refers.

Element Information

Number of occurrences | Zero or more
Parent elements | TransformationInstances
Contents | None

Remarks

TransformationInstance is executed before the OperationInstance that requires it.

XSD Schema

<s:complexType name="TransformationInstance">
   <s:attribute name="TransformationName" type="s:string" />
   <s:attribute name="TransformationMetadataSolutionName" type="s:string" />
   <s:attribute name="Index" type="s:int" use="required" />
   <s:attribute name="InputOperationIndex" type="s:int" use="required" />
   <s:attribute name="InputOperationOutputSchemaIndex" type="s:int" use="required" />
</s:complexType>


InputOperationIndex Attribute

An integer defining the source of the input Schema for this TransformationInstance.

Required | Yes
Default value | None

Remarks

This attribute's value can be one of the following:
  • Any positive integer value from 1 to N: If this attribute is set to a value between 1 and N, it specifies the value of the Index attribute of the OperationInstance element from OperationInstances attribute of the associated Action. In this case, the InputOperationOutputSchemaIndex attribute must be used to specify the Schema element.
  • 0: For input, the TransformationInstance uses the Schema that is identified by the InputSchemaName attribute of the Action associated with this TransformationInstance element.
  • -1: For input, the TransformationInstance uses the Schema identified by the SchemaName attribute of the View element associated with this TransformationInstance. If the View element does not define the SchemaName attribute, InputOperationIndex uses the DefaultReferenceSchemaName of the associated Entity element.
  • -1001: For input, the TransformationInstance uses the Schema identified by the DefaultReferenceSchemaName of the associated Entity element.

Applies To

TransformationInstance


InputOperationOutputSchemaIndex Attribute

An integer that identifies the Index attribute of the SchemaInstance element from the OutputSchemas subelement of the OperationInstance that is identified by the InputOperationIndex attribute.

Required | No
Default value | 0

Remarks

Because a given Operation can have more than one output, the Information Bridge must pick one. If this attribute not defined, it defaults to 0.

This attribute is only used if the InputOperationIndex attribute is set to a non-zero integer value.

Applies To

TransformationInstance


TransformationMetadataSolutionName Attribute

A string containing the Name attribute of the MetadataSolution element associated with this TransformationInstance.

Required | No
Default value | None


TransformationName Attribute

A string containing the Name attribute of the Transformation element to which the TransformationInstance refers.

Required | No
Default value | TransformationImmediate

Remarks

If this attribute is not defined, Information Bridge assumes this TransformationInstance refers to a TransformationImmediate element.


TransformationInstances

Metadata Designer Schema Reference

TransformationInstances Element

Contains zero or more TransformationInstance elements.

<TransformationInstances>
Content: (TransformationInstance*)
</TransformationInstances>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | OperationInstance
Contents | TransformationInstance

Remarks

Only TransformationInstance elements included in this parent element can be used on the parent element. If a parent element does not have a TransformationInstances subelement, no TransformationInstance elements will be available for that parent element.

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="TransformationInstances" type="s1:ArrayOfTransformationInstance" />
</s:sequence>


TransformationRegularExpression

Metadata Designer Schema Reference

TransformationRegularExpression Type

Applies a regular expression to the input data.

Attributes

TransformationRegularExpression is a type of Transformation. In addition to its other attributes, a Transformation of type TransformationRegularExpression includes the following attributes:

Attribute name | Type | Required | Description
Expression | string | Yes | A string containing the regular expression to apply to the SchemaInstance identified by the InputSchemaName attribute.

XSD Schema

<s:complexType name="TransformationRegularExpression">
   <s:complexContent mixed="false">
   <s:extension base="s1:Transformation">
      <s:attribute name="Expression" type="s:string" />
   </s:extension>
   </s:complexContent>
</s:complexType>


Expression Attribute

A string containing the regular expression to apply to the SchemaInstance identified by the InputSchemaName attribute.

Required | Yes
Default value | None

Remarks

This regular expression must contain at least one grouping construct. The output SchemaInstance of this TransformationRegularExpression is the match of the first grouping construct. The output SchemaInstance is null if no grouping construct is specified or if there is no match for the regular expression.

For information about regular expressions, visit the .NET Framework General Reference.

Applies To

TransformationRegularExpression


Transformations

Metadata Designer Transformation Reference

Transformations Element

Contains zero or more Transformation elements.

<Transformations>
Content: (Transformation*)
</Transformations>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Transformation

XSD Transformation

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Transformations" type="s1:ArrayOfTransformation" />
</s:sequence>


TransformationXPath

Metadata Designer Schema Reference

TransformationXPath Type

Applies an XPath expression to the input data.

Attributes

TransformationXPath is a type of Transformation. In addition to its other attributes, a Transformation of type TransformationXPath includes the following attributes:

Attributes name | Type | Required | Description
Expression | string | Yes | A string containing the XPath expression to apply to the SchemaInstance identified by the InputSchemaName attribute.
Namespace | string | No | A string containing zero or more XMLNS prefix associations corresponding to the XML namespace prefixes that are used in the Expression attribute.

Remarks

For more information about XPath expressions, see http://www.w3.org/TR/xpath/.

XSD Schema

<s:complexType name="TransformationXPath">
   <s:complexContent mixed="false">
   <s:extension base="s1:Transformation">
      <s:attribute name="Namespace" type="s:string" />
      <s:attribute name="Expression" type="s:string" />
   </s:extension>
   </s:complexContent>
</s:complexType>


Expression Attribute

A string containing the XPath expression to apply to the SchemaInstance identified by the InputSchemaName attribute.

Required | Yes
Default value | None

Remarks

For more information about XPath expressions, see http://www.w3.org/TR/xpath/.

Applies To

TransformationXPath


Namespace Attribute

A string containing zero or more XMLNS prefix associations corresponding to the XML namespace prefixes that are used in the TransformationXPath Expression attribute.

Required | No
Default value | None

Remarks

For example, if the value for Expression is

"a:books/a:book/b:Title"
then the Namespace attribute value is:
a="uri-of-namespace-prefix-a" b="uri-of-namespace-prefix-b"
In XML encoded format, the value for Namespace is:
Namespace="a=&quot;uri-of-namespace-prefix-a&quot; b=&quot;uri-of-namespace-prefix-b&quot;"

Applies To

TransformationXPath


TransformationXsl

Metadata Designer Schema Reference

TransformationXsl Type

Applies an XSL to the input data.

Attributes

TransformationXsl is a type of Transformation. In addition to its other attributes, a Transformation of type TransformationXsl includes the following attributes:

Attributes name | Type | Required | Description
ApplyTranslations | boolean | Yes | A Boolean value indicating whether or not the Translation extensibility functions are exposed to the XSLT processor when performing the TransformationXsl.
PortMetadataSolutionName | string | No | A string containing the Name attribute of the MetadataSolution element that is associated with the PortFile element identified by the PortName attribute.
PortName | string | Yes | A string containing the Name attribute of the PortFile element that either specifies a file location, or embeds the XSLT (in which case it must be of type PortFileXml.

Remarks

The TransformationXsl can be used to perform translations as part of the execution when ApplyTranslations is set to true. In this situation, to make use of the translations table the XSL must use one of the following functions (which are defined in the http://schemas.microsoft.com/InformationBridge/2004/Translator namespace):

  • Translate(key) - returns the value of the string in the translations table identified by the given key.
  • Translate(key, arg0) / Translate(key, arg0, arg1) / Translate(key, arg0, arg1, arg2) - gets the value of the string in the translations table identified by the given key as a string format template and performs a format on it with the given argument(s).

For example, the following XML:

<?xml version="1.0"?>
<customer name="John Smith"/>

and the following XSL:

<xsl:stylesheet version="1.0"
xmlns:xsl=http://www.w3.org/1999/XSL/Transform
xmlns:t="http://schemas.microsoft.com/InformationBridge/2004/Translator">
  <xsl:template match="/customer/@name">
    <header>
      <xsl:value-of select="t:Translate('nameTemplate', .)"/>
    </header>
 </xsl:template>
</xsl:stylesheet>

produces the following result on a user computer where application culture is set to en-US:

<?xml version="1.0"?>
<header>Name: John Smith</header>

or produces the following result on a user computer where application culture is set to fr-FR:

<?xml version="1.0"?>
<header>Nom: John Smith</header>

The preceding sample assumes that the translations table contains the key "nameTemplate" with the modifiers en-US and fr-FR and with the values "Name: {0}" for en-US and "Nom: {0}" for fr-FR.

For more information about XPath expressions, see http://www.w3.org/TR/xsl/.

XSD Schema

<s:complexType name="TransformationXsl">
   <s:complexContent mixed="false">
   <s:extension base="s1:Transformation">
      <s:attribute name="PortName" type="s:string" />
      <s:attribute name="PortMetadataSolutionName" type="s:string" />
      <s:attribute name="ApplyTranslations" type="s:boolean" use="required" />
   </s:extension>
   </s:complexContent>
</s:complexType>


ApplyTranslations Attribute

A Boolean value indicating whether the Translation extensibility functions are exposed to the XSLT processor when performing the TransformationXsl.

Required | No
Default value | None

Remarks

When this attribute is set to true, the XLS can make use of the Translation functions to translate the result of the TransformationXsl.

When a translation is not required, set to false for improved performance.

Remarks

TransformationXsl


Translation

Metadata Designer Schema Reference

Translation Element

Defines localization strings for translating text.

<Translation
  Key = string
  Modifier = string
  Value = string
  IsFallback = Boolean>
Content: None
</Translation>

Attributes

Attribute name | Type | Required | Description
Key | string | No | A string of up to 128 characters containing the text used to identify the appropriate value in the translation table.
Modifier | string | Yes | A string of up to 165 characters containing the ISO 639 country code of the language to which the text identified by the Key attribute will be translated.
Value | string | No | A string of up to 128 characters containing the translated text to which the text identified by the Key attribute will be translated.
IsFallback | boolean | Yes | A Boolean value indicating whether this Translation element is used as the default for the text identified by the Key attribute.

Element Information

Number of occurrences | Zero or more
Parent elements | Translations
Contents | None

Remarks

Translation elements are used when executing a Transformation of type TransformationXsl.

XSD Schema

<xs:complexType name="Translation">
   <xs:attribute name="Key" type="xs:string" />
   <xs:attribute name="Modifier" type="xs:string" />
   <xs:attribute name="Value" type="xs:string" />
   <xs:attribute name="IsFallback" type="xs:boolean" use="required" />
</xs:complexType>

Code Sample

The following code sample provides the default English translation for the phrase "Customer Name" and the Spanish translation.

<Translations>
   <Translation Key = "Customer Name" Modifier = "en-us" Value = "Customer Name" IsFallback = "true"></Translation>
   <Translation Key = "Customer Name" Modifier = "es" Value = "Nombre del cliente" IsFallback = "false"></Translation>
</Translations>


IsFallback Attribute

A Boolean value indicating whether this Translation element is used as the default for the text identified by the Key attribute.

Required | Yes
Default value | False

Remarks

This provides a default Value attribute when the requested Value attribute is not available. If no default is specified, Information Bridge returns nothing. Specify only one default value per Key entry.

If more than one Translation element with the same Key attribute value is created with IsFallback set to true, the Metadata Designer, upon importing the XML, accepts the first such Translation with IsFallback equal to true. However, all subsequent Translation elements with the same Key attribute value are redefined to IsFallback equal to false. To avoid this, only define one IsFallback equal to true for each Key value.

Applies To

Translation


Key Attribute

A string of up to 128 characters containing the text used to identify the appropriate value in the translation table.

Required | No
Default value | None

Remarks

For example, the value for this attribute could be Customer Name.

Applies To

Translation


Modifier Attribute

A string of up to 165 characters containing the ISO 639 country code of the language to which the text identified by the Key attribute will be translated.

Required | Yes
Default value | None

Remarks

For example, the value of this attribute could be en-US for English in the United States, en-UK for English in the United Kingdom, or en for English anywhere. For a list of country codes, see http:\\www.iso.org\.

Applies To

Translation


Value Attribute

A string of up to 128 characters containing the translated text to which the text identified by the Key attribute will be translated.

Required | No
Default value | None

Remarks

For example, the value of this attribute for the Spanish translated text for Customer Name could be Nombre del cliente.

The Value attribute can also be used as a formatting template. For example, a Translation could be used to replace the {0} in the following example with the correct customer name:

The customer name could {0} could not be found.

Applies To

Translation


Translations

Metadata Designer Translations Reference

Translations Element

Contains zero or more Translations elements.

<Translations>
Content: (Translation*)
</Translations>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | MetadataScope
Contents | Translation

XSD Translations

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Translations" type="s1:ArrayOfTranslations" />
</s:sequence>


View

Metadata Designer Schema Reference

View Element

Defines how an Entity can be structured.

<View
  Name = string
  SchemaName = name of a Schema element
  IsList = Boolean
  Comments = string>
Content: (Actions?), (MenuItemDefinition?), (Relationships?), (ViewLocators?)
</View>

Attributes

Attribute name | Type | Required | Description
Comments | string | No | A string up to 16 kilobytes in size that contains comments about this View element. These comments appear in the Metadata Designer tool, and to anyone editing the metadata files directly.
IsList | boolean | Yes | An informational Boolean value indicating whether this View represents a single item or a list of items.
Name | string | Yes | A string of up to 64 characters in size containing the unique identifier for this View.
SchemaName | string | No | A string containing the Name attribute of the Schema element that describes the data for this View.

Element Information

Number of occurrences | Zero or more
Parent elements | Views
Contents | Actions, MenuItemDefinition, Relationships, ViewLocators

Remarks

A View is a data cross-section on an Entity, for example the financial data on a customer or the address data on a customer. The View is defined by the Schema of the data identified by the SchemaName attribute. There are many ways to retrieve that data. For example, the system could retrieve the address of a customer by name or by customer number. However, the result is data that adheres to a single schema.

Different roles in an organization need different views on the same entity. For example, a sales representative and a financial person need different views on the customer. A sales representative needs to know about appointments and opportunities, and the financial person needs to know whether the customer paid his bills. However, this does not always mean they cannot see the other information. Looking at the previous example, one can imagine an SAP-customer-base-info view, an SAP-customer-sales-info view, and an SAP-customer-financial-info view.

The data for the view is implicitly retrieved from the responsible service whenever needed, such as for the execution of an Action, to follow a Relationship, or to show data to the user.

XSD Schema

<s:complexType name="View">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="MenuItemDefinition" type="s1:MenuItemDefinition" />
      <s:element minOccurs="0" maxOccurs="1" name="ViewLocators" type="s1:ArrayOfViewLocator" />
      <s:element minOccurs="0" maxOccurs="1" name="Actions" type="s1:ArrayOfAction" />
      <s:element minOccurs="0" maxOccurs="1" name="Relationships" type="s1:ArrayOfRelationship" />
   </s:sequence>
   <s:attribute name="Name" type="s:string" />
   <s:attribute name="SchemaName" type="s:string" />
   <s:attribute name="IsList" type="s:boolean" use="required" />
   <s:attribute name="Comments" type="s:string" />
</s:complexType>


IsList Attribute

An informational Boolean value indicating whether this View represents a single item or a list of items.

Required | Yes
Default value | False

Remarks

This attribute is used for informational purposes only - it does not define any behavior. The default value is false.

For example, a single ViewLocator element could return a View for a single customer given that person's Social Security number. Alternately, a list View could return a list of customers by state of residence.

Multiple ViewLocator elements (lists) should only be associated with Action elements with a Type attribute of EnterContext.

Applies To

View


SchemaName Attribute

A string containing the Name attribute of the Schema element that describes the data for this View.

Required | No
Default value | False

Remarks

This is the Schema returned by ViewLocator elements associated with this View.

Applies To

View


ViewLocator

Metadata Designer Schema Reference

ViewLocator Element

Used to navigate from a reference to the content of a View.

<ViewLocator
  ReferenceSchemaName = name of a Schema element>
Content: (OperationInstance?), (PortInstance?)
</ViewLocator>

Attributes

Attribute name | Type | Required | Description
ReferenceSchemaName | string | No | A string containing the Name attribute of the Schema passed to the OperationInstance subelement.

Element Information

Number of occurrences | Zero or more
Parent elements | ViewLocators
Contents | PortInstance, OperationInstance

Remarks

Information Bridge can get to a View in multiple ways. For example, Information Bridge can get customer information either by name or by ID. Both provide the same View. Although an Entity can have multiple references, for simplicity Information Bridge provides them in the View. This design requires that the Entity reference be unique, so Information Bridge can create an implicit navigation to the default View. This is so you know the schema for that reference. If you enter context on a specific View, you must be able to choose the reference schema you want, or otherwise the View must support the Entity reference schema.

The OperationInstance subelement takes the SchemaInstance element. That, in turn, is identified by the ReferenceSchemaName element as the input SchemaInstance element of the Operation element, which is identified by the OperationName attribute of the OperationInstance element.

If the PortInstance subelement is specified, it modifies the Port element defined by the Operation element that is associated with the OperationInstance subelement.

The PortInstance subelement is helpful for Operation elements that have associated Port elements (OperationBrowse, OperationCallComponent, OperationCustom, OperationSoapRequestand OperationStatusCheck). If this ViewLocator is not associated with one of these Operation elements, the PortInstance subelement is not used.

XSD Schema

<s:complexType name="ViewLocator">
   <s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
      <s:element minOccurs="0" maxOccurs="1" name="OperationInstance" type="s1:OperationInstance" />
      <s:element minOccurs="0" maxOccurs="1" name="PortInstance" type="s1:PortInstance" />
   </s:sequence>
   <s:attribute name="ReferenceSchemaName" type="s:string" />
</s:complexType>


ReferenceSchemaName Attribute

A string containing the Name attribute of the Schema passed to the OperationInstance subelement of the ViewLocator.

Required | No
Default value | None

Remarks

This attribute's value should match the value for the SchemaName attribute of the View element with which this ViewLocator is associated.

The Schema element identified by this attribute cannot have a MetadataSolution element defined in the MetadataSolutionName attribute.

Applies To

ViewLocator


ViewLocators

Metadata Designer Schema Reference

ViewLocators Element

Contains zero or more ViewLocator elements.

<ViewLocators>
Content: (ViewLocator*)
</ViewLocators>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | View
Contents | ViewLocator

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="ViewLocators" type="s1:ArrayOfViewLocator" />
</s:sequence>


Views

Metadata Designer Schema Reference

Views Element

Contains zero or more View elements.

<Views>
Content: (View*)
</Views>

Attributes

None.

Element Information

Number of occurrences | Zero or one
Parent elements | Entity
Contents | View

Remarks

Only View elements included in this Views element can be used on the parent Entity element. If an Entity does not have a Views subelement, no View elements are available for that Entity.

XSD Schema

<s:sequence xmlns:s="http://www.w3.org/2001/XMLSchema">
   <s:element minOccurs="0" maxOccurs="1" name="Views" type="s1:ArrayOfView" />
</s:sequence>


Information Bridge Framework Metadata Schema Reference

Metadata Designer Schema Reference

Documentation Conventions

The Microsoft Office Information Bridge Framework Metadata Schema Reference uses the following documentation conventions.

Outside of code snippets, italicized text represents code that should be replaced by actual values.

Outside of code snippets, bold text indicates data types, elements, and attributes.

Code snippets and samples are presented in monospace font in a grey background:

<Action Name="Action01"/>

The following operators are used to indicate the requirements and numbers of element content.

Operator | Element may appear
? | Zero or one time.
* | Zero or more times
+ | One or more times


Information Bridge Framework Metadata Schema Reference

Metadata Designer Schema Reference

Element Reference

The following is a list of all the elements in the metadata:

  • Action
  • Actions
  • AuthenticationDefinitionOperationInstance
  • Entities
  • Entity
  • EntityTimestamp
  • EntityTimestamps
  • Group
  • Groups
  • InputSchemas
  • IsEnabledOperationInstance
  • IsVisibleOperationInstance
  • LocationOperationInstance
  • MenuDefinitionOperationInstance
  • MenuItemDefinition
  • Metadata
  • MetadataScope
  • MetadataScopes
  • MetadataScopeTimestamp
  • MetadataScopeTimestamps
  • MetadataSolution
  • MetadataSolutions
  • MetadataTimestamp
  • Operation
  • OperationBrowse
  • OperationCallComponent
  • OperationCustom
  • OperationExecuteAction
  • OperationInstance
  • OperationInstances
  • OperationNavigate
  • OperationQueryMenu
  • OperationReturnActionResult
  • Operations
  • OperationSoapRequest
  • OperationStatusCheck
  • OperationTransformationAggregation
  • OperationType
  • OperationTypes
  • OutputSchemas
  • Port
  • PortAssembly
  • PortFile
  • PortFileBinary
  • PortFileText
  • PortFileXML
  • PortInstance
  • PortInstances
  • Ports
  • PortSoap
  • Properties
  • Relationship
  • Relationships
  • Schema
  • SchemaInstance
  • Schemas
  • SchemaString
  • SchemaXsd
  • Transformation
  • TransformationImmediate
  • TransformationImmediatePort
  • TransformationInstance
  • TransformationInstances
  • TransformationRegularExpression
  • Transformations
  • TransformationXPath
  • TransformationXsl
  • Translation
  • Translations
  • View
  • ViewLocator
  • ViewLocators
  • Views


Version Attribute

A string of up to 64 characters containing the version portion of the strong name for the assembly.

Required | No
Default value | None

Applies To

PortAssembly


TransformationName Attribute

A string containing the Name attribute of the Transformation element applied to current View element.

Required | Yes
Default value | None

Remarks

If a View with this Name attribute does not exist, Information Bridge instead navigates to the default View for the Entity identified by the TargetEntityName attribute.

Applies To

Relationship